#include "vidinter.h"  // Video interface
#include "timer.h"     // Interrupt driven timer
#include "fileio.h"    // Read and write files
#include "depend.h"    // OS dependent stuff
#include "button.h"    // Push buttons
#include "viewmgr.h"   // View manager
#include "actids.h"	   // Action ids
#include "dialog.h"
#include "strbox.h"
#include "chkbox.h"
#include "colors.h"

#ifdef __MSDOS__
#include <dos.h>       // Needed for msdos
#include <alloc.h>
#include <conio.h>
#endif

#define BEEP_ID 10
#define EXIT_ID 20
#define ASK_QUIT_ID 30
#define CC_ID 40

ViewMgr mainMgr;

DeclareObjH( Beep )
{
    static char buffer[30];
	// check if object is clicked with left mouse button
    if ( isClick( msg, LEFT_PRESSED )) {
        sprintf (buffer, "coreleft: %u bytes", coreleft () );
        ((Button*)msg->ToObj)->CSetName( buffer );
        ((Button*)msg->ToObj)->CShowObject();
    }

    return 0;
}

DeclareObjH( Quit )
{
    if ( msg->actId == YESNO_YES )
		mainMgr.CStopLoop(); // stop the main loop
	else if ( isClick( msg, LEFT_PRESSED )) {
		if ( ((CheckBox*)mainMgr.CGetObject( ASK_QUIT_ID ))->CStatus() )
			mainMgr.CStopLoop();
		else
            yesno( " Really quit!? ", msg->ToObj );
	}

	return 0;
}

void v_ResetColors( void );
DeclareObjH( CColor )
{
    static BBOOL changed;
    if ( isClick( msg, LEFT_PRESSED ) ) {
        beep( 500, 10 );
        if ( changed ) {
            changed = FALSE;
            v_ResetColors();
        } else {
            changed = TRUE;

            FaceColor       = 88;
            TextColor       = 128;
            BtnUpColor      = 90;
            BtnLowColor     = 85;
            HighLiteColor   = 184;
            OutLineColor    = 103;

//            FaceColor       = v_cBLUE;
//            TextColor       = v_cWHITE+v_cBRIGHT;
//            BtnUpColor      = v_cRED+v_cBRIGHT;
//            BtnLowColor     = v_cORANGE;
//            HighLiteColor   = v_cCYAN+v_cBRIGHT;
//            OutLineColor    = v_cGREEN+v_cBRIGHT;
        }
        mainMgr.CShowAllObject();
	}
	return 0;
}

main ()
{
    // Register two push buttons
//    mainMgr.CRegObject(new Button( 10, 10, 200, 20, Beep, BEEP_ID, "Memory" ));

    mainMgr.CRegObject(new Button( 10, 24, 46, 34, Quit, EXIT_ID, "Quit" ));
//    mainMgr.CRegObject(new CheckBox( 49, 24, 59, 34, ASK_QUIT_ID) );

//    mainMgr.CRegObject(new StrBox( 10, 38, 200, 47, 11230,
//                        string( "abcdefghijklmnopqrstuvwxyz" ) ));

//    mainMgr.CRegObject(new StrBox( 10, 52, 40, 62, 14571,
//                        string( "string box #2")));

//    mainMgr.CRegObject(new StrBox( 10, 66, 300, 76, 19845,
//                           string( "string box #3" )));

    mainMgr.CRegObject(new StrBox( 10, 80, 250, 90, 18234,
			   string( "Yet another string box.")));

//    mainMgr.CRegObject(new StrBox( 10, 94, 300, 104, 1845,
//                           string( "I am not a string box!!! ha!!!")));

    mainMgr.CRegObject(new CheckBox( 203, 38, 213, 48, 8512 ) );

    mainMgr.CRegObject(new Button( 204, 10, 308, 20, CColor, CC_ID,
                        "Change Color"));

	_InitVideo;  // macro to Initialize Video

    // Load and set standard pallete.(msdos only)

    #ifdef __MSDOS__

    char far *pals = readfile( "data\\standard.pal");
    v_PutPal( pals );

    #endif

    // Show all objects to screen
    mainMgr.CShowAllObject();


    // Enter Main loop

    m_ShowMouse;

    Timer::CInstallTimer();

    mainMgr.CMgrLoop();

    Timer::CRemoveTimer();

//    getch();
    _RestoreVideo;
    return (0);
}
