#include <stdlib.h>
#include "vidinter.h"  // Video interface
#include "timer.h"     // Interrupt driven timer
#include "fileio.h"    // Read and write files
#include "depend.h"    // OS dependent stuff
#include "button.h"    // Push buttons
#include "viewmgr.h"   // View manager
#include "actids.h"	   // Action ids
#include "dialog.h"
#include "strbox.h"
#include "chkbox.h"
#include "colors.h"
#include "keys.h"

#ifdef __MSDOS__
#include <dos.h>       // Needed for msdos
#include <alloc.h>
#include <conio.h>
#endif

#define GRID_SIZE           4
#define MAX_TYPES           4
#define MAX_OPERS           7
#define MAX_OBJS            500

#define EXIT_ID             10
#define ASK_QUIT_ID         20
#define SELOPER_ID          30
#define OPER_ID             32
#define SELNEW_OBJ_ID       40
#define EDIT_MGR_ID         50
#define SHOW_TYPE_ID        60
#define EDIT_ID             70
#define TEST_ID             80
#define SHOW_TEST_ID        90
#define SAVE_ID             100
#define LOAD_ID             110
#define SNAP_BUT_ID         120
#define SNAP_CHK_ID         130
#define GRID_BUT_ID         140

#define MOVE_OBJ            0
#define RESIZE_OBJ          1
#define DELETE_OBJ          2
#define CUT_OBJ             3
#define COPY_OBJ            4
#define PASTE_OBJ           5
#define OBJ_INFO            6

#define TEST_ACTIVATE       1000
#define GET_FILE_NAME       1010
#define SET_TYPE            1020

DeclareObjH(Editor);
DeclareObjH(ActivateEditViewMgr);
void ShowGrids( void );
void Gridize( int *i, int s );
void RestoreObjs( void );

//int Canvas_X = 320, Canvas_Y = 240;
int Canvas_X = 320, Canvas_Y = 200;     //andadd
ViewMgr mainMgr;
ViewMgr editMgr( 0, 20, Canvas_X, Canvas_Y + 20, 0, Editor, EDIT_MGR_ID, 1 );

int NewObjType = -1;
int OperType = -1;
int Operating = 0;
int Testing = 0;
int ClipBoard = -1;
int CutClipBoard = -1;
int CustomBaseID = 300;

char* none = "None";
char* on = "On";
char* off = "Off";
char* ok = " OK ";
char* cancel = "Cancel";
// Menus
char* names[] = { "ScrObj",
                  "Button",
                  "ChkBox",
                  "StrBox",
		  "Cancel"
                };
char* opers[] = { "Move Object",
                  "Resize Object",
                  "Delete Object",
                  "Cut Object",
                  "Copy Object",
                  "Paste Object",
                  "Object Info",
                  "Cancel"
                };

char* showGridStr = "Show Grid";
char* hideGridStr = "Hide Grid";
char buffer[256];
CheckBox *SnapToGrid;
BBOOL ShowGrid = TRUE;

class ObjInfo
{
public:
    ScrObj *ObjPtr;
    char *comment1;
    char *comment2;
    char *Id_name;
    char *name;
    char *HandlerName;
    char *BitmapFile;
    char *ClassName;


    ObjInfo(void) {
        ObjPtr = 0;
        comment1 = comment2 = Id_name = name = HandlerName =
        BitmapFile = ClassName = 0;
    }
    ObjInfo(int s) {
        ObjPtr = 0;
        comment1 = new char[s];
        comment2 = new char[s];
        Id_name = new char[s];
        name = new char[s];
        HandlerName = new char[s];
        BitmapFile = new char[s];
        ClassName = new char[s];
        CClear();
    }
    void CClear(void);
    ~ObjInfo() {
        delete comment1;
        delete comment2;
        delete Id_name;
        delete name;
        delete HandlerName;
        delete BitmapFile;
        delete ClassName;
    }
    void CSetInfo( char *idname, char *handn, char *_Name = 0,
              char *cmt1 = 0, char *cmt2 = 0, char *BmpFile = 0,
              char *ClName = 0 )
    {
        comment1 = cmt1;
        comment2 = cmt2;
        Id_name = idname;
        name = _Name;
        HandlerName = handn;
        BitmapFile = BmpFile;
        ClassName = ClName;
    }
    ObjInfo& operator=( ObjInfo &y );

};

void ObjInfo::CClear(void)
{
    if ( comment1 ) comment1[0] = 0;
    if ( comment2 ) comment2[0] = 0;
    if ( Id_name ) Id_name[0] = 0;
    if ( name ) name[0] = 0;
    if ( HandlerName ) HandlerName[0] = 0;
}

ObjInfo& ObjInfo::operator=( ObjInfo &y )
{
    if ( this == &y )
        return *this;
    if ( ObjPtr == 0 )
        ObjPtr = y.ObjPtr;
    delete comment1;
    delete comment2;
    delete Id_name;
    delete name;
    delete HandlerName;
    comment1 = comment2 = Id_name = name = HandlerName = 0;
    int len;
    if ( y.comment1 && (len = strlen(y.comment1)) > 0) {
        comment1 = new char [len+1];
        strcpy( comment1, y.comment1 );
    }
    if ( y.comment2 && (len = strlen(y.comment2)) > 0 ) {
        comment2 = new char [len+1];
        strcpy( comment2, y.comment2 );
    }
    if ( y.Id_name && (len = strlen(y.Id_name)) > 0 ) {
        Id_name = new char [len + 1];
        strcpy( Id_name, y.Id_name );
    }
    if ( y.name && (len = strlen(y.name)) > 0 ) {
        name = new char [len + 1];
        strcpy( name, y.name );
    }
    if ( y.HandlerName && (len = strlen(y.HandlerName)) > 0 ) {
        HandlerName = new char[len + 1];
        strcpy( HandlerName, y.HandlerName );
    }
    return *this;
}


ObjInfo ObjSlots[MAX_OBJS];


#define LOCX 0
#define LOCY 300

DeclareIntCNoPtr ( beezzz )
{
    static WORD idx = 0;
    idx ++;
    sprintf (buffer, " %5u ", idx);
    v_ShowMsg (0, 310, TextColor, FaceColor, buffer );
    return 0;
}

DeclareIntCNoPtr(UpdateMsg )
{
    static int oldMx, oldMy;
    static int newMx, newMy;
    oldMx = newMx;
    oldMy = newMy;
    newMx = m_MouseX;
    newMy = m_MouseY;
	if (oldMx != newMx || oldMy != newMy ) {
        sprintf( buffer, "X= %d  Y= %d", newMx, newMy - 20);
        v_ShowMsgLen( LOCX, LOCY, 120, TextColor, FaceColor, buffer );
    }
    return 0;
}

DeclareObjH( NewObjectHandler )
{
    if ( msg->ToObj->identify() == BUTTON_ID )
        if ( isClick( msg, LEFT_PRESSED ))
            ;
    return 0;
}

DeclareObjH( Test )
{
    if ( isClick( msg, LEFT_PRESSED )
        || msg->actId == TEST_ACTIVATE ) {
        if ( Operating ) {
            RestoreObjs();
            Operating = 0;
        }
        Button *show = (Button*)mainMgr.CGetObject( SHOW_TEST_ID );
        if ( !show ) return -1;
        if ( Testing ) {
            editMgr.CSetHandler( Editor );
            show->CSetName( off );
            Testing = 0;
        } else {
            editMgr.CSetHandler( ActivateEditViewMgr );
            show->CSetName( on );
            Testing = 1;
        }
        show->CShowObject();
    }
    return 0;
}

void swap( int *a, int *b )
{
    int t;
    t = *a;
    *a = *b;
    *b = t;
}

void Gridize( int *i, int s )
{
    if ( SnapToGrid->CStatus() ) {
        int k = *i % s;

        if ( k == 0 ) return;
        if ( k >= s / 2)
            *i = *i + (s - k);
        else
            *i = *i - k;
    }
}

WORD CreateObject( int x1, int y1, int x2, int y2, int id = 0 )
{
    ScrObj *tmp;
    int NewObjectID = -1;
    int i;

    if ( NewObjType == -1 )
        return 0;
    if ( x1 > x2 )
        swap( &x1, &x2 );
    if ( y1 > y2 )
        swap( &y1, &y2 );
    if ( x2 - x1 < GRID_SIZE || y2 - y1 < GRID_SIZE ) {
        return 0;
    }
    if ( id <= 0 ) {
        for( i = 0; i < MAX_OBJS; i ++ ) {
            if (ObjSlots[i].ObjPtr == 0) {
                NewObjectID = CustomBaseID + i;
                break;
            }
        }
    } else if ( id > 0 && id <= MAX_OBJS) {
        i = id - 1;
        if ( ObjSlots[i].ObjPtr == 0 )
            NewObjectID = i + CustomBaseID;
    }
    if ( NewObjectID == -1 ) {
        printf("Error in CreateObject, bug!.\n");
        return 0;
    }
    switch( NewObjType ) {
        case 0: // ScrObj
            tmp = new ScrObj( x1, y1, x2, y2, NewObjectHandler, NewObjectID );
            break;
        case 1: // Button
            tmp = new Button( x1, y1, x2, y2, NewObjectHandler, NewObjectID, "" );
            break;
        case 2: // ChkBox
            tmp = new CheckBox( x1, y1, x2, y2, NewObjectID );
            break;
        case 3: // StrBox
            tmp = new StrBox( x1, y1, x2, y2, NewObjectID, string("strbox"));
            break;
        default:
            return 0;
    }
    editMgr.CRegObject(tmp);
    tmp->CShowObject();
    ObjSlots[i].ObjPtr = tmp;
    return NewObjectID;
}

DeclareObjH( SetType )
{
    if ( isClick( msg, LEFT_PRESSED ) || msg->actId == SET_TYPE ) {
        if ( NewObjType < 0 )
           NewObjType = 0;
        else
           NewObjType ++ ;
        if ( NewObjType >= MAX_TYPES ) {
            NewObjType = 0 ;
        }
        Button *me = (Button*)msg->ToObj;
        me->CSetName( names[NewObjType]);
        me->CShowObject();
    }
    return 0;
}

DeclareObjH( SelectObjectOperation )
{
    static Dialog *dlg = 0;
    static Button *btn[MAX_OPERS+1];
    int i, id;

    switch( msg->actId ) {
        case DESTROY_DIALOG:
            if ( dlg ) {
                for( i = 0; i < MAX_OPERS+1; i ++ ) {
                    delete btn[i];
                }
                delete dlg;
            }
            dlg = 0;
            return 0;
        case 0:
        case MOUSE_OFF:
            break;
        default:
            return 0;
    }
    if ( isClick( msg, LEFT_PRESSED )) {
        if ( dlg == 0 ) {
            int inc = 19;
            dlg = new Dialog( 180, 15, 296, 128, 0, 126 );
            for (i = 1; i < MAX_OPERS+2; i ++ ) {
                btn[i-1] = new Button( 184, inc+(i-1)*10, 292, inc+i*10,
                                       SelectObjectOperation, i, opers[i-1] );
                dlg->CRegObject(btn[i-1]);
                inc += 3;
            }
            ViewMgr::CSendMsg( dlg, INSTALL_DIALOG, msg->ToObj );
        } else {
            Button *show = (Button*)mainMgr.CGetObject( OPER_ID );
            if ( !show ) return -1;
            id = msg->ToObj->CGetID();
            if (id > 0 && id < MAX_OPERS+1 ) {
                OperType = id - 1;
                show->CSetName(opers[OperType]);
                ViewMgr::CSendMsg( dlg, DIALOG_CONFIRM, 0 );
            } else if ( id == MAX_OPERS+1 ) {
                OperType = -1;
                show->CSetName(none);
                ViewMgr::CSendMsg( dlg, DIALOG_CANCEL, 0 );
            }
            show->CShowObject();
        }
    }
    return 0;
}


void RestoreObjs( void )
{
    ScrObj *tmp;
    int i;
    Operating = 0;
    for( i = 0; i < MAX_OBJS; i ++ ) {
        if ( ObjSlots[i].ObjPtr != 0 ) {
            tmp = ObjSlots[i].ObjPtr;
            if ( !tmp->CSetDefaultHand())
                tmp->CSetHandler( NewObjectHandler );
        }
    }
    editMgr.CSetHandler( Editor );
    editMgr.CStopLoop();
}

DeclareObjH( MoveObj )
{
    static int x1, y1, x2, y2;
    static ScrObj *movingObj;
    static int mx, my, omx, omy;

    if ( msg->actId == -1 ) {
        movingObj = (ScrObj*)msg->ToObj;
        x1 = movingObj->x1();
        y1 = movingObj->y1();
        x2 = movingObj->x2();
        y2 = movingObj->y2();
        mx = objMouseX;
        my = objMouseY;
        Gridize( &mx, GRID_SIZE );
        Gridize( &my, GRID_SIZE );
        editMgr.CStopLoop();
        editMgr.CMakeMouseOnNoObject();
        editMgr.CSetHandler(MoveObj);
        return 0;
    }
    switch ( msg->actId ) {
        case 0:
            break;
        default:
            return 0;
    }
    omx = mx;
    omy = my;
    mx = objMouseX;
    my = objMouseY;
    Gridize( &mx, GRID_SIZE );
    Gridize( &my, GRID_SIZE );
    if((omx != mx || omy != my) && msg->mouButton & HOLD ) {
        m_HideMouse;
        v_XRectangle( x1, y1, x2, y2, OutLineColor );
        x1 += (mx-omx);
        x2 += (mx-omx);
        y1 += (my-omy);
        y2 += (my-omy);
        v_XRectangle( x1, y1, x2, y2, OutLineColor );
        m_ShowMouse;
    } else if ( msg->mouButton & CLICK ) {
        movingObj->CSetUpper( x1, y1 );
        movingObj->CSetLower( x2, y2 );
        ShowGrids();
        editMgr.CShowAllObject();
        RestoreObjs();
    }
    return 0;
}


DeclareObjH( ResizeObj )
{
    static int x1, y1, x2, y2, ox2, oy2;
    static ScrObj *resizingObj;

    if ( msg->actId == -1 ) {
        resizingObj = (ScrObj*)msg->ToObj;
        x1 = resizingObj->x1();
        y1 = resizingObj->y1();
        x2 = resizingObj->x2();
        y2 = resizingObj->y2();
        ox2 = objMouseX;
        oy2 = objMouseY;
        Gridize( &ox2, GRID_SIZE );
        Gridize( &oy2, GRID_SIZE );
        editMgr.CStopLoop();
        editMgr.CMakeMouseOnNoObject();
        editMgr.CSetHandler(ResizeObj);
        v_XRectangle( x1, y1, x2, y2, OutLineColor );
        return 0;
    }
    switch ( msg->actId ) {
        case 0:
            break;
        default:
            return 0;
    }
    ox2 = x2;
    oy2 = y2;
    x2 = objMouseX;
    y2 = objMouseY;
    Gridize( &x2, GRID_SIZE );
    Gridize( &y2, GRID_SIZE );
    if((ox2 != x2 || oy2 != y2) && msg->mouButton & HOLD ) {
        sprintf(buffer, "x1=%d y1=%d x2=%d y2=%d  [%d by %d]",
                x1, y1, x2, y2, abs(x2-x1), abs(y2-y1));
        v_ShowMsgLen( 0, 320, 400, TextColor, FaceColor, buffer );
        m_HideMouse;
        v_XRectangle( x1, y1, ox2, oy2, OutLineColor );
        v_XRectangle( x1, y1, x2, y2, OutLineColor );
        m_ShowMouse;
    } else if ( msg->mouButton & CLICK ) {
        if ( x1 > x2 )
            swap( &x1, &x2 );
        if ( y1 > y2 )
            swap( &y1, &y2 );
        resizingObj->CSetUpper( x1, y1 );
        resizingObj->CSetLower( x2, y2 );
        ShowGrids();
        editMgr.CShowAllObject();
        RestoreObjs();
    }
    return 0;
}

DeclareObjH(ObjectInfo)
{
#define OFFX 200
#define OFFY 200
    static Dialog *oi_dlg = 0;
    static StrBox idName(OFFX+84, OFFY+4, OFFX+260, OFFY+16, 200, 0);
    static StrBox HandStr(OFFX+84, OFFY+20, OFFX+260, OFFY+32, 201,0);
    static StrBox ObjName(OFFX+84, OFFY+36, OFFX+260, OFFY+48, 202, 0);
    static StrBox Cmt1(OFFX+84, OFFY+52, OFFX+260, OFFY+64, 203, 0 );
    static StrBox Cmt2(OFFX+84, OFFY+68, OFFX+260, OFFY+80, 204, 0);
    static StrBox x1Field(OFFX+32, OFFY+84, OFFX+60, OFFY+96, 205, 0 );
    static StrBox y1Field(OFFX+96, OFFY+84, OFFX+124, OFFY+96, 206, 0 );
    static StrBox x2Field(OFFX+32, OFFY+100, OFFX+60, OFFY+112, 207, 0 );
    static StrBox y2Field(OFFX+96, OFFY+100, OFFX+124, OFFY+112, 208, 0 );
    static Button OKBut(OFFX+208, OFFY+84, OFFX+260, OFFY+96, ObjectInfo,
                     211, "OK" );
    static Button Cancel(OFFX+208, OFFY+100, OFFX+260, OFFY+112, ObjectInfo,
                        212, "Cancel");
    static ScrObj *workingObj;
    static int x1, y1, x2, y2, id, i;
    static ObjInfo *tmp;
    static char *x1str, *y1str, *x2str, *y2str;

    switch( msg->actId ) {
        case -1:
            if ( oi_dlg == 0 ) {
                workingObj = (ScrObj*)msg->ToObj;
                x1 = workingObj->x1();
                y1 = workingObj->y1() - 20;
                x2 = workingObj->x2();
                y2 = workingObj->y2() - 20;
                id = workingObj->CGetID();
                i = id - CustomBaseID;
                if ( i < 0 ) {
                    fprintf( stderr, "index %d negative. ObjectInfo!\n", i );
                    return 0;
                }
                oi_dlg = new Dialog(OFFX+0, OFFY+0, OFFX+264, OFFY+116, 0, 146 );
                oi_dlg->CRegObject( &idName);
                oi_dlg->CRegObject( &HandStr);
                oi_dlg->CRegObject( &ObjName);
                oi_dlg->CRegObject( &Cmt1);
                oi_dlg->CRegObject( &Cmt2);
                oi_dlg->CRegObject( &OKBut);
                oi_dlg->CRegObject( &Cancel);
                oi_dlg->CRegObject( &x1Field );
                oi_dlg->CRegObject( &y1Field );
                oi_dlg->CRegObject( &x2Field );
                oi_dlg->CRegObject( &y2Field );
                tmp = new ObjInfo;
                *tmp = ObjSlots[i];
                tmp->ObjPtr = 0;
                // All the string pointers passed to strboxes will be alter
                // and therefore becomes useless to the caller.  This is
                // strbox's sideeffect.  However, the alteration will not occur
                // until the strbox's editor is activated.  Nevertheless, it
                // will be no longer save to assume that pointers passed to
                // strbox are valid!
                idName.CSetName(tmp->Id_name);
                HandStr.CSetName(tmp->HandlerName);
                ObjName.CSetName(tmp->name);
                Cmt1.CSetName(tmp->comment1);
                Cmt2.CSetName(tmp->comment2);
                delete x1str;
                delete y1str;
                delete x2str;
                delete y2str;
                x1Field.CSetName((x1str = new char[5]));
                y1Field.CSetName((y1str = new char[5]));
                x2Field.CSetName((x2str = new char[5]));
                y2Field.CSetName((y2str = new char[5]));
                sprintf( x1str, "%3d", x1 );
                sprintf( y1str, "%3d", y1 );
                sprintf( x2str, "%3d", x2 );
                sprintf( y2str, "%3d", y2 );
                ViewMgr::CSendMsg( oi_dlg, INSTALL_DIALOG, &OKBut );
            }
            return 0;
        case DESTROY_DIALOG:
            delete oi_dlg;
            oi_dlg = 0;
            idName.CSetName(0);
            HandStr.CSetName(0);
            ObjName.CSetName(0);
            Cmt1.CSetName(0);
            Cmt2.CSetName(0);
            x1Field.CSetName(0);
            y1Field.CSetName(0);
            x2Field.CSetName(0);
            y2Field.CSetName(0);
            delete tmp;
            ShowGrids();
            editMgr.CShowAllObject();
            tmp = 0;
            return 0;
        case 0:
        case MOUSE_OFF:
            break;
        case INSTALL_DIALOG:
            m_HideMouse;
            v_ShowMsgLen(OFFX+4, OFFY+6,  76,
                        TextColor, FaceColor, " ID_Name:");
            v_ShowMsgLen(OFFX+4, OFFY+22, 76,
                        TextColor, FaceColor, " Handler:");
            v_ShowMsgLen(OFFX+4, OFFY+38, 76,
                        TextColor, FaceColor, "    Name:");
            v_ShowMsgLen(OFFX+4, OFFY+54, 76,
                        TextColor, FaceColor, "Comment1:");
            v_ShowMsgLen(OFFX+4, OFFY+70, 76,
                        TextColor, FaceColor, "Comment2:");
            v_ShowMsg( OFFX+4, OFFY+86, TextColor, FaceColor, "x1");
            v_ShowMsg( OFFX+68, OFFY+86, TextColor, FaceColor, "y1");
            v_ShowMsg( OFFX+4, OFFY+102, TextColor, FaceColor, "x2");
            v_ShowMsg( OFFX+68, OFFY+102, TextColor, FaceColor, "y2");
            sprintf( buffer, "%1d x %1d", x2-x1, y2-y1 );
            v_ShowMsg( OFFX+132, OFFY+86, TextColor, FaceColor, buffer );
            sprintf( buffer, "ID %1u", id );
            v_ShowMsg( OFFX+132, OFFY+102, TextColor, FaceColor, buffer );
            m_ShowMouse;
            return 0;
        default:
            return 0;
    }
    if ( isClick( msg, LEFT_PRESSED )) {
        if ( oi_dlg != 0 ) {
            id = msg->ToObj->CGetID();
            switch( id ) {
                case 211:
                case 212:
                // Reassign tmp so we can clean up the memory belongs to tmp's
                // string pointers, which have been passed to strboxes for
                // manipulation.  This way, no matter strbox change the string
                // pointers passed to it or not, we can just delete tmp and
                // clean up.
                    tmp->CSetInfo( idName.CStr(), HandStr.CStr(),
                        ObjName.CStr(), Cmt1.CStr(), Cmt2.CStr() );
                    x1str = x1Field.CStr();
                    y1str = y1Field.CStr();
                    x2str = x2Field.CStr();
                    y2str = y2Field.CStr();
                    if ( id == 211 ) {
                        ObjSlots[i] = *tmp; // Make a copy of tmp, which is to
                                            // be delete
                        if (ObjSlots[i].ObjPtr) {
                            ScrObj &t = *(ObjSlots[i].ObjPtr);
                            t.CSetUpper( atoi(x1str), atoi(y1str)+20);
                            t.CSetLower( atoi(x2str), atoi(y2str)+20);
                        }
                        ViewMgr::CSendMsg( oi_dlg, DIALOG_CONFIRM, 0 );
                    } else
                        ViewMgr::CSendMsg( oi_dlg, DIALOG_CANCEL, 0 );
                    break;
                default:
                    break;
            }
        }
    }
    return 0;
}

DeclareObjH( DoObjOper )
{
    Object *tmp;
    int i;

    if ( msg->mouButton & HOLD ) {
        switch(OperType) {
            case MOVE_OBJ:
                ((Message*)msg)->actId = -1;
                MoveObj(msg);
                return 0;
            case RESIZE_OBJ:
                ((Message*)msg)->actId = -1;
                ResizeObj(msg);
                return 0;
        }
    } else if ( msg->mouButton == LCLICK ) {
        tmp = msg->ToObj;
        i = tmp->CGetID() - CustomBaseID;
        if ( i < 0 ) {
            fprintf(stderr, "%d index negative DoObjOper.\n", i );
            return 0;
        }
        if (ObjSlots[i].ObjPtr != (ScrObj*)tmp ) {
            fprintf(stderr, "DoObjOper: oops!\n");
            return 0;
        }
        switch(OperType) {
            case DELETE_OBJ:
                editMgr.CUnRegObjByPtr( tmp );
                ObjSlots[i].ObjPtr = 0;
                delete tmp;
                ShowGrids();
                editMgr.CShowAllObject();
                editMgr.CReset();
                break;
            case CUT_OBJ:
                CutClipBoard = i;
                editMgr.CUnRegObjByPtr( tmp );  // Remove it
                ShowGrids();
                editMgr.CShowAllObject();
                editMgr.CReset();
                break;
            case COPY_OBJ:
                ClipBoard = i;
                break;
            case OBJ_INFO:
                ((Message*)msg)->actId = -1;
                ObjectInfo(msg);
                break;
            default:
                break;
        }
        RestoreObjs();
    }
    return 0;
}

DeclareObjH( ObjectOperation )
{
    Object *tmp;
    int i;

    if ( msg->actId && msg->actId != MOUSE_OFF ) return 0;
    if( msg->ToObj->CGetID() == OPER_ID && isClick( msg, LEFT_PRESSED )) {
        if ( OperType == PASTE_OBJ ) {
            if ( ClipBoard < 0 )
                return 0;
            int type = NewObjType;
            ScrObj *tmp = ObjSlots[ClipBoard].ObjPtr;
            if ( !tmp ) return 0;
            NewObjType = tmp->identify();
            switch( NewObjType ) {
                case SCROBJ_ID:
                    NewObjType = 0;
                    break;
                case BUTTON_ID:
                    NewObjType = 1;
                    break;
                case CHKBOX_ID:
                    NewObjType = 2;
                    break;
                case STRBOX_ID:
                    NewObjType = 3;
                    break;
                default:
                    fprintf( stderr, "DoObjOper: unknown type. %d\n",
                            NewObjType );
                    NewObjType = type;
                    return 0;
            }
            int NewID = CreateObject(tmp->x1(), tmp->y1(),
                tmp->x2(), tmp->y2());
            NewID -= CustomBaseID;
            if ( NewID >= 0 ) {
                ObjSlots[NewID] = ObjSlots[ClipBoard];
                ShowGrids();
                editMgr.CShowAllObject();
                editMgr.CReset();
            }
            NewObjType = type;
            return 0;
        }
        if ( Testing ) {
            ((Message*)msg)->actId = TEST_ACTIVATE;
            Test( msg );    /* Call Test handler directly */
        }
        if ( Operating == 0 ) {
            for( i = 0; i < MAX_OBJS; i ++ ) {
                if ( ObjSlots[i].ObjPtr != 0 ) {
                    tmp = ObjSlots[i].ObjPtr;
                    tmp->CSetHandler( DoObjOper );
                }
            }
            editMgr.CSetHandler( ActivateEditViewMgr );
            Operating = 1;
        } else {
            RestoreObjs();
            Operating = 0;
        }
    }
    return 0;
}


DeclareObjH( SelectNewObject )
{
    static Dialog *dlg = 0;
    static Button *btn[MAX_TYPES+1];
    static int m = -1;
    int i, id;

    switch( msg->actId ) {
        case DESTROY_DIALOG:
            if ( dlg ) {
                for( i = 0; i < MAX_TYPES+1; i ++ ) {
                    delete btn[i];
                }
                delete dlg;
            }
            dlg = 0;
            return 0;
        case MOUSE_ON:
            id = msg->ToObj->CGetID();
            switch( id ) {
                case 1:
                case 2:
                case 3:
                case 4:
                    sprintf(buffer, "Create a new object of type %s ",
                            names[id-1]);
                    break;
                case 5:
                    sprintf(buffer, "Do not create a new object.");
                    break;
                case SELNEW_OBJ_ID:
                    sprintf(buffer, "Create a new object.");
                    break;
                default:
                    return 0;
            }
            if ( m != id ) {
                v_ShowMsgLen( 0, 330, 300, TextColor, FaceColor, buffer );
                m = id;
            }
            return 0;
        case 0:
        case MOUSE_OFF:
            break;
        default:
            return 0;
    }
    if ( isClick( msg, LEFT_PRESSED )) {
        if ( dlg == 0 ) {
            int inc = 19;
            dlg = new Dialog( 40, 15, 120, 85, 0, 126 );
            for (i = 1; i < MAX_TYPES+2; i ++ ) {
                btn[i-1] = new Button( 44, inc + (i-1) * 10, 116, inc + i * 10,
                                       SelectNewObject, i, names[i-1] );
                dlg->CRegObject(btn[i-1]);
                inc += 3;
            }
            ViewMgr::CSendMsg( dlg, INSTALL_DIALOG, msg->ToObj );
        } else {
            Button *show = (Button*)mainMgr.CGetObject( SHOW_TYPE_ID );
            if ( !show ) return -1;
            id = msg->ToObj->CGetID();
            if (id > 0 && id < MAX_TYPES+1 ) {
                NewObjType = id - 1;
                show->CSetName(names[NewObjType]);
                ViewMgr::CSendMsg( dlg, DIALOG_CONFIRM, 0 );
            } else if ( id == MAX_TYPES+1 ) {
                NewObjType = -1;
                show->CSetName(none);
                ViewMgr::CSendMsg( dlg, DIALOG_CANCEL, 0 );
            }
            show->CShowObject();
        }
    }

    return 0;
}

DeclareObjH( Quit )
{
    if ( msg->actId == YESNO_YES )
		mainMgr.CStopLoop(); // stop the main loop
	else if ( isClick( msg, LEFT_PRESSED )) {
            yesno( " Really quit!? ", msg->ToObj );
	}

	return 0;
}

DeclareObjH( ActivateEditViewMgr )
{
    ViewMgr *winThis = (ViewMgr*)msg->ToObj;
    ViewMgr *boss = (ViewMgr*)CurrentMgr;
    if ( msg->actId == MOUSE_ON )
        UpdateMsg(0);
    else
    if ( !msg->actId && boss->CGiveUpControl() && msg->mouButton & HOLD ) {
        ViewMgr::CMakeMouseOnNoObject();

        winThis->CRestoreOutLine();
		winThis->CDrawOutLine( HighLiteColor );
		winThis->CMgrLoop();

        m_HideMouse;
		winThis->CDrawOutLine( OutLineColor );
        m_ShowMouse;

		return 1;
    }
	return 0;
}

DeclareObjH(Editor)
{
    static int penOn = 0;
    static int x1, y1, oldx, oldy, x2, y2;


    switch( msg->actId ) {
        case MOUSE_OFF:
        case KEY_DOWN:
            return 0;
    }
    UpdateMsg(0);
    int hold = (msg->mouButton & HOLD);

    if ( hold ) {
        if ( penOn == 0 ) {
            penOn = 1;
            x1 = objMouseX;
            y1 = objMouseY;
            Gridize( &x1, GRID_SIZE );
            Gridize( &y1, GRID_SIZE );
            oldx = x2 = x1;
            oldy = y2 = y1;
            return 0;
        } else {
            oldx = x2;
            oldy = y2;
            x2 = objMouseX;
            y2 = objMouseY;
            Gridize( &x2, GRID_SIZE );
            Gridize( &y2, GRID_SIZE );
            if (oldx != x2 || oldy != y2) {
                sprintf(buffer, "x1=%d y1=%d x2=%d y2=%d  [%d by %d]",
                        x1, y1, x2, y2, abs(x2-x1), abs(y2-y1));
                v_ShowMsgLen( 0, 340, 400, TextColor, FaceColor, buffer );
                m_HideMouse;
                v_XRectangle( x1, y1, oldx, oldy, OutLineColor );
                v_XRectangle( x1, y1, x2, y2, OutLineColor );
                m_ShowMouse;
            }
        }
    } else if ( penOn ) {
        penOn = 0;
        if (msg->mouButton == LCLICK) {
            m_HideMouse;
            v_XRectangle( x1, y1, x2, y2, OutLineColor );
            m_ShowMouse;
            CreateObject( x1, y1, x2, y2 );
        } else if (msg->mouButton == RCLICK ) {
        } else if (msg->actId == CANCEL_CLICK) {
            m_HideMouse;
            v_XRectangle( x1, y1, x2, y2, OutLineColor );
            m_ShowMouse;
        }
    }
    return 0;
}

void Save( char* filename )
{
    int i, id = CustomBaseID;
    FILE *file;
    file = fopen ( filename, "w");
    if ( !file ) {
        printf("open file failed.\n");
        return;
    }
    ScrObj *t;
    ObjInfo *os;
    fprintf( file, "$%u\n", (WORD)CustomBaseID);
    for ( i = 0; i < MAX_OBJS; i ++ ) {
        os = &ObjSlots[i];
        t = os->ObjPtr;
        if ( t ) {
            if ( os->Id_name )
                fprintf( file, ".i%s\n", os->Id_name );
            if ( os->HandlerName )
                fprintf( file, ".h%s\n", os->HandlerName );
            if ( os->name )
                fprintf( file, ".n%s\n", os->name );
            if ( os->comment1 )
                fprintf( file, "!1%s\n", os->comment1 );
            if ( os->comment2 )
                fprintf( file, "!2%s\n", os->comment2 );

            switch( t->identify() ) {
                case SCROBJ_ID:
                    fprintf( file, ":%5d ScrObj\n", SCROBJ_ID);
                    break;
                case BUTTON_ID:
                    fprintf( file, ":%5d Button\n", BUTTON_ID);
                    break;
                case CHKBOX_ID:
                    fprintf( file, ":%5d ChkBox\n", CHKBOX_ID);
                    break;
                case STRBOX_ID:
                    fprintf( file, ":%5d StrBox\n", STRBOX_ID);
                    break;
                default:
                    break;
            }
            fprintf( file, "@OFFX+%d, OFFY+%d, OFFX+%d, OFFY+%d\n",
                            t->x1(), t->y1() - 20, t->x2(), t->y2() - 20);
            fprintf( file, "#%u\n", id );
            fprintf( file, "~\n");
            id ++;
        }
    }
}


void ScanPosition( char *b, int *x1, int *y1, int *x2, int *y2 )
{
    int val[4], i = 0;

    while( *b != 0 ) {
        if ( *b == '+' ) {
            sscanf( b+1, "%d", &val[i]);
            i ++;
        }
        b ++;
    }
    *x1 = val[0];
    *y1 = val[1] + 20;
    *x2 = val[2];
    *y2 = val[3] + 20;
}

void Load( char* filename )
{
    FILE *file;
    int x1, y1, x2, y2, len;
    int type, id, oldtype = NewObjType;
    ObjInfo tmpOI(256);

    file = fopen( filename, "r");
    if ( file == NULL ) {
        printf("open file for reading failed.\n");
        return ;
    }
    while( fgets( buffer, 1024, file ) ) {
        len = strlen( buffer );
        if ( len > 0 ) len --;
        else
            fprintf(stderr, "load: string too short.\n");
        buffer[len] = 0;
        switch( buffer[0] ) {
            case '$':
                sscanf( buffer+1, "%d", &CustomBaseID );
                break;
            case '.':
                if ( len < 3 ) {
                    fprintf( stderr, "load: string '%s' short!\n", buffer );
                    break;
                }
                switch( buffer[1]) {
                    case 'i':
                        strcpy( tmpOI.Id_name, buffer+2 );
                        break;
                    case 'h':
                        strcpy( tmpOI.HandlerName, buffer+2);
                        break;
                    case 'n':
                        strcpy( tmpOI.name, buffer+2 );
                        break;
                    default:
                        break;
                }
                break;
            case '!':
                if ( len < 4 ) {
                    fprintf( stderr, "load: string '%s' short!\n", buffer );
                    break;
                }
                if ( buffer[1] == '1' ) {
                    strcpy( tmpOI.comment1, buffer+2 );
                } else {
                    strcpy( tmpOI.comment2, buffer+2 );
                }
                break;
            case ':':
                sscanf( buffer+1, "%d", &type );
                switch( type ) {
                    case SCROBJ_ID:
                        NewObjType = 0;
                        break;
                    case BUTTON_ID:
                        NewObjType = 1;
                        break;
                    case CHKBOX_ID:
                        NewObjType = 2;
                        break;
                    case STRBOX_ID:
                        NewObjType = 3;
                        break;
                    default:
                        printf("Load: Unknown Object type id: %d\n", type );
                        break;
                }
                break;
            case '@':
                ScanPosition( buffer, &x1, &y1, &x2, &y2 );
                break;
            case '#':
                sscanf( buffer+1, "%d", &id );
                break;
            case '~':
                WORD NewID;
                NewID = CreateObject( x1, y1, x2, y2, id-(CustomBaseID - 1));
                if ( NewID >= CustomBaseID ) {
                    NewID -= CustomBaseID;
                    ObjSlots[NewID] = tmpOI;
                }
                tmpOI.CClear();
                break;
            default:
                break;
        }
    }
    NewObjType = oldtype;
}

DeclareObjH( SaveLoad )
{
    static Dialog *sldlg = 0;
    static Button *btnOk, *btnCancel;
    static StrBox getfilename( 204, 230, 394, 244, 12345, 0, SaveLoad );
    static int which = 0; // 0 == save  1 == load

    switch( msg->actId ) {
        case DESTROY_DIALOG:
            if ( sldlg ) {
                delete sldlg;
                delete btnOk;
                delete btnCancel;
            }
            sldlg = 0;
            return 0;
        case DIALOG_CANCEL:
            return 0;
        case GET_FILE_NAME:
            if ( sldlg == 0 ) {
                sldlg = new Dialog( 200, 200, 400, 274, 0, 136 );
                btnOk = new Button( 220, 255, 280, 266, SaveLoad, 1, "OK" );
                btnCancel = new Button( 320, 255, 380, 266, SaveLoad,
                                        2, "CANCEL" );
                sldlg->CRegObject( &getfilename );
                sldlg->CRegObject( btnOk );
                sldlg->CRegObject( btnCancel );
                ViewMgr::CSendMsg( sldlg, INSTALL_DIALOG, msg->ToObj );
            }
            return 0;
        case DIALOG_CONFIRM:
            if (which == 0 ) {
                Save(getfilename.CStr());
            } else if ( which == 1 ) {
                Load(getfilename.CStr());
            }
            which = -1;
            return 0;
        case 0:
        case MOUSE_OFF:
            break;
        case INSTALL_DIALOG:
            sprintf(buffer, "Enter Filename to ");
            if ( !which ) {
                strcat( buffer, "save.");
            } else
                strcat( buffer, "load.");
            v_ShowMsg( v_CenterMsgX( 200, 400, buffer ), 210,
                       TextColor, FaceColor, buffer );
            return 0;
        case KEY_DOWN:
            if ( msg->ToObj->CGetID() == 12345 )
                if ( msg->keyDown == ENTER )
                    ViewMgr::CSendMsg( sldlg, DIALOG_CONFIRM, msg->ToObj );
                else if ( msg->keyDown == ESC )
                    ViewMgr::CSendMsg( sldlg, DIALOG_CANCEL, msg->ToObj );
            return 0;
        default:
            return 0;
    }
    if ( isClick( msg, LEFT_PRESSED )) {
        switch( msg->ToObj->CGetID()) {
            case 1:
                ViewMgr::CSendMsg( sldlg, DIALOG_CONFIRM, msg->ToObj );
                break;
            case 2:
                ViewMgr::CSendMsg( sldlg, DIALOG_CANCEL, msg->ToObj );
                break;
            case SAVE_ID:
                mainMgr.CSendMsg( msg->ToObj, GET_FILE_NAME, 0 );
                which = 0;
                break;
            case LOAD_ID:
                mainMgr.CSendMsg( msg->ToObj, GET_FILE_NAME, 0 );
                which = 1;
                break;
            default:
                break;
        }
    }
    return 0;
}

DeclareObjH( SnapChange )
{
    if ( isClick( msg, LEFT_PRESSED )) {
        SnapToGrid->CToggle();
    }
    return 0;
}

DeclareObjH( GridChange )
{
    if ( isClick( msg, LEFT_PRESSED ))
    {
        ShowGrid = !ShowGrid;
        ShowGrids();
        editMgr.CShowAllObject();
        if ( ShowGrid )
            ((Button*)msg->ToObj)->CSetName( hideGridStr );
        else
            ((Button*)msg->ToObj)->CSetName( showGridStr );
        ((Button*)msg->ToObj)->CShowObject();

    }
    return 0;
}

void SetupObjects( void )
{
    mainMgr.CRegObject(new Button( 2, 2, 36, 12, Quit, EXIT_ID, "Quit" ));
    mainMgr.CRegObject(new Button( 40, 2, 126, 12, SelectNewObject,
                                   SELNEW_OBJ_ID, "New Object"));
    mainMgr.CRegObject(new Button( 128, 2, 184, 12, SetType,
                                   SHOW_TYPE_ID, none ));
    mainMgr.CRegObject(new Button( 190, 2, 280, 12, SelectObjectOperation,
                                   SELOPER_ID, "Operations"));
    mainMgr.CRegObject(new Button( 282, 2, 392, 12, ObjectOperation,
                                   OPER_ID, none ));
    mainMgr.CRegObject(new Button( 398, 2, 434, 12, Test, TEST_ID, "Test"));
    mainMgr.CRegObject(new Button( 436, 2, 464, 12, Test, SHOW_TEST_ID, off ));
    mainMgr.CRegObject(new Button( 470, 2, 506, 12, SaveLoad,
                                   SAVE_ID, "Save"));
    mainMgr.CRegObject(new Button( 510, 2, 546, 12, SaveLoad,
                                   LOAD_ID, "Load"));
    mainMgr.CRegObject(new Button( 4, 268, 104, 278, SnapChange,
                                   SNAP_BUT_ID,
                                   "Snap To Grid" ));
    SnapToGrid = new CheckBox( 106, 268, 116, 278, SNAP_CHK_ID );
    mainMgr.CRegObject( SnapToGrid );

    mainMgr.CRegObject(new Button( 120, 268, 194, 278, GridChange,
                                   GRID_BUT_ID, hideGridStr ));
    mainMgr.CRegInt( beezzz );
    mainMgr.CRegObject(&editMgr);
}

void ShowGrids( void )
{
    int i;
    m_HideMouse;
    editMgr.CClrContext();
    if ( ShowGrid) {
        for ( i = 20; i < Canvas_Y+20; i += GRID_SIZE )
            v_PutLine( 0, i, Canvas_X, i, BtnLowColor );
        for ( i = 0; i < Canvas_X; i += GRID_SIZE )
            v_PutLine( i, 20, i, Canvas_Y+20, BtnLowColor );
    }
    editMgr.CHighLiteOutLine();
    m_ShowMouse;
}


main ()
{
    SetupObjects();
	_InitVideo;  // macro to Initialize Video

    // Load and set standard pallete.(msdos only)
     // Show all objects to screen
    mainMgr.CShowAllObject();
    SnapToGrid->CUpdate( TRUE );
    ShowGrids();
/*
    for( int i = 0; i < MAX_OBJS; i ++ )
        ObjSlots[i] = 0;
*/

    m_MouseWindow( 0, 0, 600, 400 );
    // Enter Main loop
    m_ShowMouse;
    Timer::CInstallTimer();
    mainMgr.CMgrLoop();
    Timer::CRemoveTimer();

    _RestoreVideo;
    return (0);
}
