#include <stdio.h>
#include "debug.h"
#include "macros.h"

#ifdef __MSDOS__
#include <dos.h>
#endif

#ifdef __LINUX__
#include <errno.h>
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

//
// Read a file into an unsigned char far buffer and return the pointer
// Takes the name of the file
//
char far* _pascal_ readfile(char *filenamein )
{
	char far *ibuff = NULL;
	#ifdef __MSDOS__
    unsigned infilesize, nread;
    #endif
    
    #ifdef __LINUX__
    long infilesize;
    int nread;
    #endif
    
    FILE *fi;

	fi = fopen( filenamein,"rb+" );
	if ( !fi ) return 0;

	fseek ( fi, 0, SEEK_END );
	infilesize = (unsigned) ftell(fi);
	fseek ( fi, 0, SEEK_SET );

	ibuff = new char far [infilesize];
    if ( !ibuff ) return 0;

	#ifdef __MSDOS__
    int fih = fileno( fi );
    _dos_read( fih, ibuff, infilesize, &nread );
    #endif
    
    #ifdef __LINUX__
    fread( (void*) ibuff, sizeof(char), infilesize, fi );
	#endif
	
/*	if ferror( fi ) {
		delete ibuff;
		return 0;
	}*/

    fclose(fi);
    return ibuff;
}

//
// Write a char far buffer to a file with size bytes
// Takes name of file to be written, pointer to buffer, and size of buffer
//
// returns number of bytes actually written
//
unsigned _pascal_
writefile( char *filenameout, char far *obuff, unsigned size )
{
	#ifdef __MSDOS__
    unsigned nwrite;
    #endif
    
	FILE *fo;

    fo = fopen( filenameout,"wb+" );
	if ( !fo ) return 0;

	#ifdef __MSDOS__
	int foh = fileno( fo );
    _dos_write( foh, (void far*)obuff, size, &nwrite );
    #endif
    
    #ifdef __LINUX__
    size_t nwrite = fwrite( (const void*) obuff, sizeof(char), size, fo );
    #endif

/*	if ferror( fo ) return 0; */

	fclose(fo);
    return nwrite;
}
