#ifndef _FILEUTIL_H_
#define _FILEUTIL_H_

#include <stdio.h>

#include "depend.h"
#include "macros.h"


extern char *OrigDir, *WorkDir;     // Original & Working working Directory

// Don't really use these
char * _pascal_ CreateTempFileName( char *name );
int _pascal_ FileExist( char *name );

// Read all of a small file(prefer < 64k) into memory and return
// the pointer to that memory.
char _FAR_* _pascal_ readfile( char *filenamein, int &BufSize,
                               char _FAR_ *buf = 0 );
// Write a some data in memory (prefer < 64k) to file.
unsigned  _pascal_ writefile( char *filenameout,
                              char _FAR_ *obuff, unsigned size );
// Use for the .ini files
//
// c = first char of the string to search
// bufPtr = buffer use to read from the file.
//                ( the function doesn't have its own)
// f = the file pointer to read data from
// str = the rest of the string.  If this is zero, then any line start with
//       c will satisfy the search.
//
char * _pascal_ FindString( char c, char *bufPtr, FILE *f, char *str = 0 );
//
// c = first char of the string to read values from
// val = array of integer to receive the values
// f = file pointer to read data from
// limit = the number of values to read
// str = if this string is nonzero, the search stops when it's reached.
//
int _pascal_ FetchValues( char c, int *val, FILE *f,
                            int limit, char *str = 0 );

// Save Current working directory
char *PushDir( void );

// Change to a full path (i.e. D:\windows\ )
void _pascal_ Chdir( char *path );

// Change back to a pushed directory.  And copy the saved dir
// name into path if path is nonzero.
int PopDir( char *path = 0);

// To save the original directory( OrigDir ) and use the WorkDir( where the
// executable is), call this with argv[0].  Before exit, make sure do
// a PopDir() to restore the original directory.
void _pascal_ InitDirs( char *wd );

#endif
