#ifdef VID_INTERFACE

#include "vgl.h"

#include "mouinter.h"  // mouse functions
#define MODE13H
#define _320x200
#include "modeinfo.h"  // the mode informations here


// Set up interface to use VGL library by Mark Morley
//
// Some general Functions
//
#define v_SetMode   vglInit()
#define v_TextMode  vglTerm()

// Draw a rectangle and fill it with color 'color'
// vglBox accepts x2 and y2 and width and height of the rect
#define v_RectFill( x1, y1, x2, y2, color ) \
    vglBox( x1, y1, x2-x1-2, y2-y1-2, color )
// vglSetPal( char pal[768] )
#define v_PutPal( buf ) vglSetPal( buf )

#define v_PutPixel(x, y, color ) vglPutPel( x, y, color )
#define v_PutLine(x1, y1, x2, y2, color ) \
    vglLine( x1, y1, x2, y2, color )


//
// Bitmap functions
//
// Grab a piece of bitmap from screen
// vgl does not have an apropriate function for this, but it's
// very easy to implement.  I took one from a book.
#define v_Getbmp( x, y, width, height, buf ) \
    __Getbmp( x, y, width, height, (char far*)buf )
// Put a piece of bitmap to screen
#define v_Putbmp( x, y, buf ) \
    __Putbmp( x, y, (char far*)buf )


//
// User font informations
//
// #define FONT_AVAILABLE
#define FONTDIR "..\\tool\\"
#define USERFONTNAME "SMALTHIN.FNT"
#define CHARS 256
#define CHARH 8


//
// Initialize and deinitialize the video/mouse
//
int  _InitMode( void );
void _DeInitMode( void );

#define _InitVideo              _InitMode()

#define AUTO_DE_INIT

#ifndef AUTO_DE_INIT
#define _RestoreVideo           _DeInitMode()
#else
#define _RestoreVideo
#endif


//
// Don't need a deinit cuz _InitXLIB handles it
// else must define it so the main program can call it when exit
//
#define _DeInitVideo


//
// Some useful routines
//
void __Getbmp( int x, int y, int width, int height, char far *buffer );
void __Putbmp( int x, int y, char far* buffer );
void __Rectangle(int x1, int y1, int x2, int y2, int color);
void __PrintMsg(int x, int y, int len, int fc, int bc, char *str );

#define v_Rectangle( x1, y1, x2, y2, color) __Rectangle(x1, y1, x2, y2, color)
#define v_PrintMsg( x, y, len, fc, bc, s ) \
	__PrintMsg( x, y, len, fc, bc, s)

#endif
