#include "dialog.h"
#include "macros.h"
#include "actids.h"
#include "button.h"
#include "vidinter.h"
#include <conio.h>
#include "keys.h"

class msg_Dlg : public Dialog
{
private:
    msg_Dlg *AskDlg;
    Button *Confirm;
    char *str1, *str2, *str3;
protected:
    msg_Dlg( char *, char *, char *, Object *req, WORD id = 0 );
	virtual void KeyBoardHandler( void );
public:
    friend DeclareObjH( msgHandler );
    friend BBOOL DisplayMsg( char*, char*, char*, Object *req );
};

void msg_Dlg :: KeyBoardHandler( void )
{
    while ( kbhit() && !EndDialog ) {
        switch( (char)getch()) {
		case ENTER:
			ViewMgr::CSendMsg( AskDlg, DIALOG_CONFIRM, 0, 0 );
			break;
		}
	}
}

DeclareObjHClass( msg_Dlg, msgHandler )
{
	WORD id = msg->ToObj->CGetID();

    if ( msg->actId && id ) {
		switch( msg->actId ) {
		case DESTROY_DIALOG:
			delete Confirm;
			delete AskDlg;
            AskDlg = 0;
            break;
		case DIALOG_CONFIRM:
        case DIALOG_CANCEL:
            break;
		case INSTALL_DIALOG:
            v_PrintMsg( v_CenterMsgX( AskDlg->x1(), AskDlg->x2(),questionStr),
						DLG_Y1 + 4, TextColor, FaceColor, questionStr );
            break;
        default:
			Button::CAction( msg, LEFT_PRESSED );  // Process mouse event
		}
    } else if ( isClick( msg, LEFT_PRESSED )) {
		int action = ( id ? DIALOG_CONFIRM : DIALOG_CANCEL );
		ViewMgr::CSendMsg( AskDlg, action, 0, 0 );
	}

    m_ShowMouse;

	return 0;
}

msg_Dlg :: msg_Dlg(char *s1, char *s2, char *s3, Object *req, WORD id)
    : Dialog( 0, 0, 0, 0, 0, id )
{
	int x1, x2;
	x2 = v_StrPixelLen( s );

	if ( x2 < 90 ) x2 = 90;

	x1 = (v_XMax - x2) / 2 - 4;
	x2 = v_XMax - x1;

	int x = ( x2 + x1 - 90 ) / 2;

	Confirm = new Button( x, 132, x + 30, 146, YesNoHandler, 1, "Yes" );
	CRegObject( Confirm );
    AskDlg = this;
    CSetUpper( x1, DLG_Y1 );
    CSetLower( x2, DLG_Y2 );
	CSendMsg( AskDlg, INSTALL_DIALOG, Confirm, 0 );
}


BBOOL DisplayMsg( char *s1, char *s2, char *s3, Object *req )
{
    new YN_Dlg( s1, s2, s3, req, 0 );
    return TRUE;
}
