#ifndef _TIMER_H_
#define _TIMER_H_

#ifndef _pascal_
#define _pascal_    pascal
#endif


#include "depend.h"

#ifdef __MSDOS__
// normal timer only has effect under msdos.
// #define NormalTimer
#endif

#ifdef __LINUX__
	#ifndef NormalTimer
	#define NormalTimer
	#endif
#endif

#ifndef NormalTimer
#include "interr.h"
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

class Timer {
private:
    unsigned elapsedTime;
    unsigned startTime;

public:
    _pascal_ Timer( unsigned dummy = 0 ) { elapsedTime = startTime = 0;}

    void _pascal_ reset( void )     { elapsedTime = startTime = 0; }
    void _pascal_ start( void );
    void _pascal_ stop( void );
    unsigned _pascal_ peekTime( void );
    unsigned _pascal_ time( void )  { return elapsedTime; }
    void _pascal_ set( unsigned t ) { startTime -= t; }
#ifndef NormalTimer
    static unsigned ticks, newDivisor;
    static void  _pascal_ ChangeSpeed( unsigned = 1, unsigned = 0xffff );
    static void  _pascal_ CRemoveTimer() { ChangeSpeed(0); }
    static int  _pascal_
        CInstallTimer( unsigned newDiv = 1, unsigned sp = 0xffff )
        {
            ChangeSpeed( newDiv, sp );
			return 1; // fast timer always work (even use as normal timer.)
        }
#else
    static void CRemoveTimer() {}
    static int  _pascal_
        CInstallTimer( unsigned newDiv = 1, unsigned sp = 0xffff )
        { return ( newDiv == 1 && sp == 0xffff ); }
#endif
};

#endif
