
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>

#include "macros.h"
#include "fileio.h"
#include "debug.h"
#include "vidint1.h"
#include "colors.h"

static char far *fpFnt;
static int _LoadFixedFont (void );

WORD VideoPage;

void _DeInitXLIB (void )
{
	m_HideMouse;
    m_MouseDeInit;
    x_text_mode ();
	delete fpFnt;
	debug_msg( "Deinit XLIB completed.\n");
}

int v_inter_c_break_handler (void )
{
	return 1;
}

void v_ResetColors( void )
{
    int i, r = 0;
    char *p;
    FaceColor = 3;          // grey
    BtnUpColor = 1;         // white
    BtnLowColor = 4;        // dark grey
    HighLiteColor = 2;      // bright orange
    OutLineColor = 5;       // Red
    TextColor = 6;          // blue

    FILE *in = fopen( "sprdesg.ini", "r");
    if ( in == NULL ) return;
    char buf[30];
    while( in ) {
        p = fgets(buf, 30, in);
        if ( p == NULL ) return;
        if ( strncmpi(buf,"[SysColors]", 11) == 0 ) break;
    }
    i = 0;
    while( 1 ) {
        p = fgets(buf, 30, in);
        if ( p == NULL ) break;
        if( buf[0] == '~' ) {
            sscanf( buf+20, "%d", &r );
            DefColors[i++] = r;
            if ( i > 6 ) break;
        }
    }
    fclose( in );
}

int _InitXLIB (void )
{
// formula to calculate extra width for the virtual screen using double buffer
// let A = 256000 - ( SplitScreenHight * PhysicalScreenHeight ) / 2
// then Extra width = A / ( PhysicalScreenHeight + DoubleBufferHeight )

    v_ResetColors();
	// Init XLIB Video mode
	x_text_mode ();
    x_set_mode ( MODE, 600 );
//    x_set_splitscreen( ScrnPhysicalHeight - v_SplitScrnHeight );
//    x_set_doublebuffer ( 200 );
//    x_hide_splitscreen();
	x_text_init ();
    
	// Load and set font
	if (_LoadFixedFont () )
		x_set_font (2 );               // use loaded font
	else
		x_set_font (0 );               // use VGA ROM 8x8 font

	// Set mouse
	m_MouseInit;

	ctrlbrk (v_inter_c_break_handler );
    #ifdef AUTO_DE_INIT
    atexit( _DeInitXLIB );
    #endif
    m_MouseCurColor ( 1 );

    VideoPage = VisiblePageOffs;

    char far *pals = readfile( "data\\standard.pal");
    v_PutPal( pals );
    x_hide_mouse();

	return 0;
}

static int _LoadFixedFont (void )
{
	fpFnt = readfile( strcat( FONTDIR, USERFONTNAME ) );
	// Register the font
	if ( fpFnt ) {
		x_register_userfont (fpFnt );
		return 1;
	} else
		return 0;
}

void _pascal_
__Rectangle (int x1, int y1, int x2, int y2, int color, WORD ScrnOffs  )
{
    x_line (x1, y1, x2, y1, color, ScrnOffs );
    x_line (x1, y1, x1, y2, color, ScrnOffs );
    x_line (x2, y1, x2, y2, color, ScrnOffs );
    x_line (x1, y2, x2, y2, color, ScrnOffs );
}

int _pascal_
__PrintMsg     ( int x, int y, int fc, int bc, int len, char *str )
{
	if ( !str ) return x;
    int y2;
    len += x;
    y2 = y + CharHeight;

    x_rect_fill( x, y, len, y2, VideoPage, bc );

    while (*str)
        x += x_char_put( *str++, x, y, VideoPage, fc );

    return x;
}

int _pascal_
__PrintMsgMA(int x, int y, int fc, int bc, int len, char *str )
{
	if ( !str ) return x;
	int x1, y1, y2;
	x1 = x - 8;
	y1 = y - 13;
	len += x;
    y2 = y + CharHeight;

    if ( MouseInRect (x1, y1, len, y2))
                                        m_HideMouse;

    x_rect_fill( x, y, len, y2, VideoPage, bc );

    while (*str )
        x += x_char_put( *str++, x, y, VideoPage, fc );

    return x;
}

int _pascal_
v_LimitPixelPrint(int x, int y, int fc, int bc, int len, char *str )
{
	if ( !str ) return x;
	int y2;
	len += x;
    y2 = y + v_CharHeight();

    x_rect_fill( x, y, len + 1, y2, VideoPage, bc );

	while (*str ) {
		if ( x + x_get_char_width( *str ) > len ) break;
        x += x_char_put( *str++, x, y, VideoPage, fc );
    }

    return x;
}


int _pascal_
v_StrPixelLen( char *str )
{
    int len = 0;
    while( *str ) len += x_get_char_width( *str++ );
    if ( CharWidth ) len--;
    return len;
}

int _pascal_
v_StrPixelLenUpTo( char *str, int slen, int plen )
{
	int x = 0, x1 = 0;
	char *limit = str + slen;

	while ( str < limit ) {
		x1 += x_get_char_width( *str++ );
        if ( x1 > plen ) break;
		x = x1;
	}

    if ( CharWidth ) x--;
	return x;
}

char* _pascal_
v_StrToFitPixels( char *begin, char *end, int len, int &newPos )
{
	int x = 0;

    while( *end ) {
        x += x_get_char_width( *end );
        if ( end == begin || x > len ) break;
        end --;
	}

	if ( x > len ) {
        end ++;
	}
    newPos = (int)(end - begin);

    return end;
}

int _pascal_ v_CenterMsgY( int y1, int y2 )
{
	return ( y2 - y1 - v_CharHeight()) / 2 + y1 + 1;
}


int _pascal_ v_CenterMsgX( int x1, int x2, char *msg )
{
    return ( x2 - x1 - v_StrPixelLen( msg )) / 2 + x1;
}

int _pascal_ v_Width4( int w )
{
    int not_even = w % 4;
    if ( not_even ) w += 4 - not_even;
    return w;
}


WORD _pascal_ _bmpsize( int w, int h)
{
    return ( v_Width4(w) * h + 4 );
}


void _pascal_ _XLine( int x1, int y1, int x2, int y2, int color )
{
    int fixed;
    if ( x2 == x1 ) {
        fixed = x1;
        int t;
        if ( y1 > y2 ) {
            t = y1;
            y1 = y2;
            y2 = t;
        }
        for( int i = y1; i < y2; i ++ ) {
            int p;
            p = v_GetPixel( fixed, i );
            _asm {
                mov ax, p
                xor ax, color
                mov p, ax
            }
            v_PutPixel( fixed, i, p );
        }
    } else {
        fixed = y1;
        int t;
        if ( x1 > x2 ) {
            t = x1;
            x1 = x2;
            x2 = t;
        }
        for( int i = x1; i < x2; i ++ ) {
            int p;
            p = v_GetPixel( i, fixed );
            _asm {
                mov ax, p
                xor ax, color
                mov p, ax
            }
            v_PutPixel( i, fixed, p );
        }
    }
}

void _pascal  __XRectangle( int x1, int y1, int x2, int y2, int color )
{
    v_XPutLine( x1, y1, x1, y2, color );
    v_XPutLine( x1, y1, x2, y1, color );
    v_XPutLine( x1, y2, x2, y2, color );
    v_XPutLine( x2, y1, x2, y2, color );
}
