#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char buffer[512];

// returns 2 to the 'x' power
#define power(x) (1<<(x))

int bintohex ( char *str );

main( int argc, char **argv )
{
    FILE *in;
    char *p;
    char varname[128];
    int CharsPrinted, TotalCharsPrinted;

    strcpy( varname, "dummy");
    if (argc < 2 ) {
        fprintf(stderr, "usage: bin2hex infile varname\n");
        exit(1);
    }
    in = fopen( argv[1], "r");
    if ( in == NULL ) {
        fprintf(stderr, "failed to open file '%s'\n", argv[1]);
        exit(2);
    }
    if ( argc == 3 )
        strcpy( varname, argv[2]);
    printf( "char %s[]={ %n", varname, &CharsPrinted );
    TotalCharsPrinted = CharsPrinted;
    int first = 0;
    while( 1 ) {
        p = fgets(buffer, 512, in);
        if ( p == NULL ) break;
        buffer[strlen(buffer)-1] = 0;  /* delete the return character */
        if ( first ) {
            printf( ", ");
            TotalCharsPrinted += 2;
        }
        if ( TotalCharsPrinted > 72 ) {
            printf( "\n    ");
            TotalCharsPrinted = 4;
        }
        printf( "%d%n", bintohex( buffer ), &CharsPrinted );
        TotalCharsPrinted += CharsPrinted;
        first = 1;
    }
    printf( " };\n");
    fclose( in );
    return 0;
}

/* bintohex.c */
/* --------------------------------------------------------------------------
   Function:            bintohex()
   Description:         read the edited character
			and convert them to hex number
   ------------------------------------------------------------------------*/
int bintohex ( char *str )
{
    int r = 0, i, cp, len = strlen(str) - 1;
    
    for ( i = len; i >= 0; i-- ) {
        if ( str[i] == 0 )
            break;
        if ( str[i] == '1' )
            cp = 1;
        else if ( str[i] == '0' )
            cp = 0;
        else
            continue;
        r += ( power( len-i ) * cp );
    }
    return r;
} /* End of function bintohex() */
