#ifndef _SMALVIEW_H_
#define _SMALVIEW_H_

#define NUM_SMALL_VIEWERS 9

class zSprite
{
private:
    char _FAR_ *data;
    // Name of the sprite
    char name[MAXFILE+MAXEXT];
    zSprite *next;

public:
    friend class zSmallView;
    friend DeclareObjH( GetPutSmallSpr );
    _pascal_ zSprite( void )
        :next(0), data(0) { name[0] = 0; }
    _pascal_ ~zSprite() { delete data; }
};

class zSmallView
{
private:
    int Count;
    int CurrentIdx;
    zSprite *head, *tail;
    zSprite *TrailPtr, *CurrentPtr;

    int ViewerCount, MoveStep;
    WORD Viewer1ID;

    zSprite *AniPtr;

    char *LibName;

public:
    _pascal_ zSmallView(void)
        :Count(0), CurrentIdx(0), head(0), tail(0),
         TrailPtr(0), CurrentPtr(0), AniPtr(0)  { SetVals(); LibName = 0; }
    _pascal_ ~zSmallView();

    void _pascal_ SetVals( int vc = NUM_SMALL_VIEWERS,
                           int ms = 3, WORD v1id = SMALL_VIEW_1_ID ) {
        ViewerCount = vc, MoveStep = ms, Viewer1ID = v1id;
    }

    void _pascal_ NewList( zSprite *temp );

        // Insert a blank sprite between TrailPtr and CurrentPtr
        // and sets CurrentPtr point to the new blank sprite
        // returns the new spr pointer if sucess or 0 for failure.
    zSprite * _pascal_ InsertBlankBefore( void );
        // Same as above except after CurrentPtr and CurrentPtr does not change
    zSprite * _pascal_ InsertBlankAfter( void );
        // Add a blank sprite to tail and return its ptr
    zSprite * _pascal_ AddBlank( void );
        // Remove Current Slot.  Returns nonzero for success or 0 for failure.
    int _pascal_ RemoveCurrent( void );
        // Set CurrentPtr's data and name to the new ones
        // Returns the CurrentIdx for success or -1 for failure
    int _pascal_ PutSprite( char _FAR_ *data, char *name = "" );
    char _FAR_ * _pascal_ GetSprite( int which );
    char _FAR_ * _pascal_ GetSprite( char *name );
        // Gets Current sprite
    char _FAR_ * _pascal_ GetSprite( void );

        // *** All three FindSprite's will set Current(ptr, idx)
        // if SetCur is nonzero

        // Find sprite number 'which' and sets CurrentPtr to that.
        // Also sets TrailPtr points to the sprite preceed.
    zSprite * _pascal_ FindSprite( int which, int SetCur = 0 );
        // Same as above except uses name as the key.
    zSprite * _pascal_ FindSprite( char *name, int SetCur = 0 );
        // Find Sprite with address == ptr and return its index.
        // returns index or -1 for failure.
    int _pascal_ FindSprite( zSprite *ptr, int SetCur = 0 );

    void _pascal_ DeleteAll( void );

    void _pascal_ DrawSpr( int x, int y );
    void _pascal_ DrawMaskedSpr( int x, int y );
    void _pascal_ DoAnimation( int x, int y, int masked );

    int _pascal_ LoadLib( void );
    int _pascal_ SaveLib( void );

    void _pascal_ SetLibName( char *n );

    friend DeclareObjH( GetPutSmallSpr );
    friend DeclareObjH( SmallViewers );
    friend DeclareObjH( SmallVDelete );
    friend DeclareObjH( ScrollLR );
    friend DeclareObjH( LoadSaveLib );
    void _pascal_ DrawSprite( ScrObj *t, zSprite *st );
    void _pascal_ RedrawSMViewers( void );
};

DeclareObjH( GetPutSmallSpr );
DeclareObjH( SmallViewers );
DeclareObjH( SmalVScrol );
DeclareObjH( ScrollLR );
DeclareObjH( SmallVDelete );
DeclareObjH( SmallVInsert );
DeclareObjH( LoadSaveLib );
void _pascal_ InitAnimate( void );


extern zSmallView SmallView;

#endif
