#ifndef _BUTTON_H_
#define _BUTTON_H_
#include "classes.h"
#include "object.h"
#include "macros.h"
#include "fileio.h"
#include "mouinter.h"

//
// Button: basically just ScrObj with some draw
//                 stuff to draw the button face
//

class Button:public ScrObj {
protected:
    char far    *bface;
    char        *zsBname;
public:
    friend class ObjMgr;

    _pascal_ Button(int x1, int y1, int x2, int y2, OBJH handler = 0,
                    WORD id = 0, char* name = 0 )
        :bface(0), zsBname( name ),
         ScrObj( x1, y1, x2, y2, handler, id )
         { }
    _pascal_ Button(): bface(0), zsBname( 0 )   { }
    _pascal_ ~Button()                          { }
    Button&      _pascal_ operator=(const Button &y);
    virtual void _pascal_ CSetFace( char far *face)   { bface = face;     }
    virtual void _pascal_ CSetName( char *str )       { zsBname = str;    }
    virtual int  _pascal_ CShowName( void );
    char far*    _pascal_ CFace   ( void )            { return bface;     }
    char*        _pascal_ CName   ( void )            { return zsBname;   }
    virtual void _pascal_ CDraw3DOutLine( BBOOL = FALSE, BBOOL = FALSE );
    virtual int  _pascal_ CRestoreOutLine( void );
    virtual int  _pascal_ CHighLiteOutLine( void );
    virtual void _pascal_ CDrawFace( void );
    virtual void _pascal_ CShowObject( void );
    virtual int  _pascal_ identify( void )                  { return BUTTON_ID; }

    static BYTE _pascal_ CAction( const Message* msg,
                                  BYTE chkBtn = LEFT_PRESSED);

    // Return the begin y pos which will make the name appear
    // at the middle of the Button vertically

    int _pascal_ CCenterMsgY( void )
    {
        return (y2() - y1() - v_CharHeight()) / 2 + y1() + 1;
    }

    int _pascal_ CCenterMsgX( void )
    {
        return (x2() - x1() - v_StrPixelLen(zsBname)) / 2 + x1();
    }
}; // end of class Button


#endif
