#include "vidinter.h"  // Video interface
#include "timer.h"     // Interrupt driven timer
#include "fileio.h"    // Read and write files
#include "depend.h"    // OS dependent stuff
#include "button.h"    // Push buttons
#include "viewmgr.h"   // View manager
#include "actids.h"	   // Action ids
#include "colors.h"
#include "keys.h"
#include <xcbitmap.h>
#include <time.h>

#ifdef __MSDOS__
#include <dos.h>       // Needed for msdos
#include <alloc.h>
#include <conio.h>
#endif

#include "map.h"
#include "mainmgr.h"
#include "dbfmouse.h"

int Frames = 0;

//
// Dummy object handler
//

DeclareObjH( DefHandler )
{
    if ( msg->ToObj->identify() == BUTTON_ID ) {
        if ( isClick( msg, LEFT_PRESSED )) {
            ;
        }
    }
    return 0;
}

main ()
{
    SetupObjects();
	_InitVideo;  // macro to Initialize Video

    VideoPage = HiddenPageOffs;
    // Show all objects to screen
    mainMgr.CShowAllObject();
    mapMgr.Init();
    v_Rectangle( 232+mapMgrPtr->MapOffX, 108+mapMgrPtr->MapOffY,
                 232+mapMgrPtr->MapOffX+13, 108+mapMgrPtr->MapOffY+11, 31 );
    m_MouseWindow( 0, 0, 315, 235 );
    x_page_flip( 0, 0 );
    x_cp_vid_rect( 0, 0, 319, 239, 0, 0,
                   VisiblePageOffs, HiddenPageOffs, 320, 320 );
    dbf_mouse_init();
    dbf_mouse_show();
    dbf_mouse_show_vispage();
    char far *pals = readfile( "data\\standard.pal");
    v_PutPal( pals );

    PageFlipping = 1;   // We will start flipping pages right away in
                        // UpdateGame.

    time_t t1, t2;

    // Enter Main loop
    Timer::CInstallTimer();

    t1 = time(0);
    mainMgr.CMgrLoop();
    t2 = time(0);

    Timer::CRemoveTimer();
    _RestoreVideo;

    int t = (int)(t2 - t1);
    int fps = Frames/t;
    printf("Frames: %d  time: %ld - %ld = %dsec  fps: %d with %d extra frames\n",
            Frames, t2, t1, t, fps, Frames - t*fps   );

    return (0);
}
