#include "vidinter.h"  // Video interface
#include "timer.h"     // Interrupt driven timer
#include "fileio.h"    // Read and write files
#include "depend.h"    // OS dependent stuff
#include "button.h"    // Push buttons
#include "viewmgr.h"   // View manager
#include "actids.h"	   // Action ids
#include "colors.h"
#include "keys.h"

#ifdef __MSDOS__
#include <dos.h>       // Needed for msdos
#include <alloc.h>
#include <conio.h>
#endif


#define _MAINMGR_MODULE_
#include "map.h"
#include "mainmgr.h"
#include "game.h"
#include "dbfmouse.h"


MainMgr mainMgr;

//
// Main manager keyboard handler
//

void MainMgr::KeyBoardHandler( void )
{
    if ( kbhit() ) {
        int key = getch();
        if ( !key ) key = getch() + 0xff;
        switch ( key ) {
            case 389:
                stop = 1;
                break;
            case LEFT:
            case RIGHT:
            case UP:
            case DOWN:
                CSendMsg( &mapMgr, KEY_DOWN, 0, 0, key );
                return;
        }
        CSendMsg( WorkObj, KEY_DOWN, 0, 0, key );
    }
}

void SetupObjects( void )
{
    mainMgr.CRegInt( UpdateGame );
//    mainMgr.CRegInt( ext_update_cursor );
    mainMgr.CRegObject(&mapMgr);
    mainMgr.CRegObject(new ScrObj(
        4, 196, 316, 208, DefHandler, 201 ));
    mainMgr.CRegObject(new Button(
        4, 212, 72, 224, DefHandler, 202, "Button1" ));
    mainMgr.CRegObject(new Button(
        88, 212, 156, 224, DefHandler, 203, "Button2" ));
    mainMgr.CRegObject(new Button(
        172, 212, 240, 224, DefHandler, 204, "Button3" ));
    mainMgr.CRegObject(new Button(
        252, 212, 316, 224, DefHandler, 205, "Button4" ));
    mainMgr.CRegObject(new ScrObj(
        231, 107, 316, 192, RadarMapHandler, RADAR_MAP_ID ));
    mainMgr.CRegObject(new ScrObj(
        232, 0, 316, 104, DefHandler, 207 ));
}

