#ifndef _SPRITE_H_
#define _SPRITE_H_
#include "macros.h"
#include "xpbitmap.h"

extern WORD VisiblePageOffs;

class bitmap {
protected:
   BYTE far *data;
   bitmap *next;
   WORD mysize;
public:
    bitmap () { data = 0; next = 0; mysize = 0; }
   ~bitmap () { delete data; }
//
// Basic functions
//
    virtual void CPut( WORD x, WORD y, WORD ScrnOffs = VisiblePageOffs );
    virtual void CPutMasked( WORD x, WORD y, WORD ScrnOffs = VisiblePageOffs );
    virtual void CGet( WORD x, WORD y, BYTE width, BYTE height,
                 WORD ScrnOffs = VisiblePageOffs );
    virtual void CSetData( BYTE far *idata );
    virtual bitmap& operator=( const bitmap &y );
// special stuff
    virtual void CSize( int orig = 1, int dest = 1 );
    virtual int  CLoad( char *filename = 0);
    friend class sprite;
};

class sprite {
protected:
    bitmap *firstbmp;
    bitmap *lastbmp;
    bitmap *current;
    WORD x, y;
    BYTE width, height;

public:
    sprite() { firstbmp = lastbmp = current = 0;
               x = y = 0; width = height = 0; }
   ~sprite();
    virtual bitmap *CAdvance( WORD ScrnOffs = VisiblePageOffs );
    virtual void   CRefresh( WORD ScrnOffs = VisiblePageOffs );
    virtual void   CMoveto( WORD dx, WORD dy ) { x = dx; y = dy; }
    virtual bitmap *CAdd( bitmap *newbmp = 0 );
    virtual void   CReset() { current = firstbmp; }
    virtual sprite& operator=( const sprite &spr );
    WORD    &sx( void ) { return x; }
    WORD    &sy( void ) { return y; }
    BYTE    &w( void ) { return width; }
    BYTE    &h( void ) { return height; }
    void    CSetWH( BYTE w, BYTE h ) { width = w; height = h; }
};

#endif
