#ifndef _BUTTON_H_
#define _BUTTON_H_
#include "classes.h"
#include "object.h"
#include "macros.h"
#include "fileutil.h"
#include "mouinter.h"

//
// Button: basically just ScrObj with some draw
//                 stuff to draw the button face
//

#define MASKED_FACE     TRUE
#define UNMASKED_FACE   FALSE

class Button:public ScrObj {
protected:
    int FaceX, FaceY;  // Bitmpa upper left (x,y) relate to button's
                       // upper left (x,y)
    char _FAR_    *bface;
    BBOOL FaceMask;
    char        *zsBname;
public:
    friend class ObjMgr;

    _pascal_ Button(int x1, int y1, int x2, int y2, OBJH handler = 0,
                    WORD id = 0, char* name = 0, char _FAR_ *bface = 0,
                    int FaceX = 0, int FaceY = 0,
                    BBOOL FaceMask = UNMASKED_FACE )
        :bface(bface), FaceX(FaceX), FaceY(FaceY), zsBname( name ),
         FaceMask(FaceMask),
         ScrObj( x1, y1, x2, y2, handler, id )    { }
    _pascal_ Button(): bface(0), zsBname( 0 )   { }
    _pascal_ ~Button()                          { }
    Button&      _pascal_ operator=(const Button &y);
    virtual void _pascal_ CSetFace( char _FAR_ *face)   { bface = face;     }
    virtual void _pascal_ CSetName( char *str )     { zsBname = str;    }
    virtual int  _pascal_ CShowName( void );
    char _FAR_*    _pascal_ CFace   ( void )        { return bface;     }
    char*        _pascal_ CName   ( void )          { return zsBname;   }
    virtual void _pascal_ CDraw3DOutLine( BBOOL = FALSE, BBOOL = FALSE );
    virtual int  _pascal_ CRestoreOutLine( void );
    virtual int  _pascal_ CHighLiteOutLine( void );
    virtual void _pascal_ CDrawFace( void );
    virtual void _pascal_ CShowObject( void );
    virtual int  _pascal_ identify( void )          { return BUTTON_ID; }

    static BYTE _pascal_ CAction( const Message* msg,
                                  BYTE chkBtn = LEFT_PRESSED);

    // Return the begin y pos which will make the name appear
    // at the middle of the Button vertically

    int _pascal_ CCenterMsgY( void )
    {
        return (sY2 - sY1 - v_CharHeight()) / 2 + sY1 + 1;
    }

    int _pascal_ CCenterMsgX( void )
    {
        return (sX2 - sX1 - v_StrPixelLen(zsBname)) / 2 + sX1;
    }
}; // end of class Button


#endif
