#include "dialog.h"
#include "mouinter.h"
#include "debug.h"
#include "button.h"
#include "vidinter.h"
#include "depend.h"

#ifdef __MSDOS__
#include <dos.h>
#endif
#include <stdio.h>

DeclareObjH( DialogHandler )
{
    Dialog *myPtr = (Dialog*)msg->ToObj;

    switch ( msg->actId ) {
        case INSTALL_DIALOG:
            myPtr->Caller = 0;
			myPtr->CInstallDialog( msg );
            ViewMgr::CSendMsg( myPtr->Caller, DESTROY_DIALOG, myPtr );
            debug_msg("Dialog destroy sent.\n");
            break;

        case DIALOG_CANCEL:
			myPtr->CRemoveDialog();
			ViewMgr::CSendMsg( myPtr->Caller, DIALOG_CANCEL, myPtr );
			debug_msg("Dialog cancel sent.\n");
			break;

		case DIALOG_CONFIRM:
			myPtr->CRemoveDialog();
            ViewMgr::CSendMsg( myPtr->Caller, DIALOG_CONFIRM, myPtr, 0 );
//            ViewMgr::CLinkSendMsg( myPtr->ObjHead, DIALOG_CONFIRM, myPtr, 0 );
            debug_msg("Dialog confirm sent.\n");
            break;

    }
    return 0;
}

void _pascal_ Dialog::CInstallDialog( const Message *msg )
{
    if ( msg->Caller )  {
        Caller = (Object*)msg->Caller;   // Remember who request this dialog

        EndDialog = FALSE;

		CResetObjectHandler();
        ViewMgr::CSendMsg( Caller, INSTALL_DIALOG, 0, 0 );
		CMgrLoop();
        debug_msg("Dialog Loop done.\n");
		CResetObjectHandler();
    }
}

void _pascal_ Dialog::CRemoveDialog( void )
{
    if ( EndDialog ) return;
    if ( Current )
        ((ScrObj*)Current)->CRestoreOutLine();

    stop = EndDialog = TRUE;
	CRestoreScrn();

    m_ShowMouse;
}

void _pascal_ Dialog::CStopLoop( void )
{
//    ViewMgr::CSendMsg( (Object*)this, DIALOG_CANCEL, 0, 0 );
}

BBOOL _pascal_ Dialog::CGiveUpControl()
{
    if ( EndDialog ) return TRUE;
    beep( 10000, 5 );
    return FALSE;
}

void _pascal_ Dialog::CSaveScrn()
{
    int width, height;
    width = (x2() - x1() + 1);
    height = (y2() - y1() + 1);

    WORD datasize = v_BMPsize(width, height);
    delete SaveScreen;

    SaveScreen = new char _FAR_ [datasize];
    if ( SaveScreen )
        v_Getbmp( x1(), y1(), width, height, SaveScreen );
}

void _pascal_ Dialog::CShowObject( void )
{
    m_HideMouse;
    CSaveScrn();        // save the screen dialog will cover
    v_RectFill( x1(), y1(), x2(), y2(), FaceColor );
    v_Rectangle( x1(), y1(), x2()-1, y2()-1, BtnUpColor );
    v_Rectangle( x1()+1, y1()+1, x2(), y2(), BtnLowColor );
    CShowAllObject();
    m_ShowMouse;
}

void _pascal_ Dialog::CRestoreScrn()
{
    if ( SaveScreen ) {
        m_HideMouse;
        v_Putbmp( x1(), y1(), SaveScreen );
        delete SaveScreen;
        SaveScreen = 0;
    }
}
