#ifndef _DIALOG_H_
#define _DIALOG_H_

#include "classes.h"
#include "actids.h"
#include "viewmgr.h"
#include "object.h"
#include <assert.h>

#ifndef DLG_BASE_MGR
#define DLG_BASE_MGR ViewMgr
#endif

class Dialog:public DLG_BASE_MGR{
protected:
    BBOOL       EndDialog;
    char _FAR_    *SaveScreen;
    Object      *Caller;

    virtual void  _pascal_ CSaveScrn( void );
    virtual void  _pascal_ CRestoreScrn( void );
    virtual void  _pascal_ CInstallDialog( const Message *msg );
    virtual void  _pascal_ CRemoveDialog( void );

public:
     _pascal_ Dialog(int x1, int y1, int x2, int y2,
                    Object *object = 0, WORD id = 0 )
            :DLG_BASE_MGR( x1, y1, x2, y2, object, DialogHandler, id, 1 ),
             EndDialog( TRUE ), SaveScreen(0)
             { }
     _pascal_ Dialog( void )
        :DLG_BASE_MGR( 0, 0, 0, 0, 0, DialogHandler, 0, 1 ),
         EndDialog(TRUE),
         SaveScreen(0)
         { }
     _pascal_ ~Dialog() { delete SaveScreen; }
    virtual void _pascal_ CShowObject( void );
    virtual BBOOL _pascal_ CGiveUpControl( void );
    virtual int  _pascal_ identify( void )              { return DIALOG_ID; }
    virtual void _pascal_ CStopLoop   (void );

	friend DeclareObjH(DialogHandler);
};
BBOOL  _pascal_ yesno( char *s, Object *req );

#endif
