#include "actids.h"
#include "macros.h"
#include "linklist.h"


/////////////////////////////////////
//                                 //
// LinkList member functions       //
//                                 //
/////////////////////////////////////

//
//      This function does not deallocate the item
//      it only remove the item from the list
//
BBOOL _pascal_ LinkList::RemoveItem( ListItem *item )
{
    ListItem *tmpPtr, *trailPtr;

    tmpPtr = ListHead;
    trailPtr = 0;
    
    if (item == 0 ) return FALSE;       // Make sure it's not a dummy pointer
    if (item == Current ) Current = 0; // Can't directly unreg current
                                       // because need to ensure the item
                                       // before current is not lost.

    while ( tmpPtr ) {
        if ( tmpPtr == item ) {       // found

            if (!tmpPtr->next )     // Tail or only one item

                if (!trailPtr )       // check if only one
                    ListTail = ListHead= 0;  // only one => all gone
                else {
                    trailPtr->next = 0;      // it's tail! take it out.
                    ListTail = trailPtr;
                }

            else if (trailPtr)              // in Middle?
                // take it out of the link.  We don't have to
                // worry about it being tail because that's checked
                // already above.
                trailPtr->next = tmpPtr->next;
            else                               // else it's head
                // take out head.  Again, we don't have to worry
                // about it being tail.
                ListHead = tmpPtr->next;

            TotalItem--;
            return TRUE;
        }
        trailPtr = tmpPtr;
        tmpPtr = tmpPtr ->next;
	}
	return FALSE;

} // end of protected function RemoveItem

//
//      Public member to add an item to end of the list.
//
BBOOL _pascal_ LinkList::CAddItem (ListItem *item )
{
    ListItem *tmpPtr;
    tmpPtr = ListHead;

    int i = 0;

    while ( tmpPtr ) {
        //
        // Can't register the same item twice.
        //
        if ( tmpPtr == item )
            return FALSE;

        tmpPtr = tmpPtr->next;

#ifdef _FATAL_FILE_
        if ( i >= TotalItem ) {
            FILE *fp = fopen( "fatal", "a+");
            fprintf( fp, "In manager.cpp: LinkList::CRegObject. CodeGt.\n");
            fclose( fp );
            while(1);
        }
#endif
        i ++;
    }

    //
    // We have an empty list, so create a list with only one item
    //
    if (!ListHead)
        ListHead = ListTail= item;
    else {
        //
        // Append to end of the list
        //
        ListTail->next = item;
        ListTail = item;
    }
    //
    // Make sure this is the last in the list.
    //
    item->next = 0;

    TotalItem ++;
    return TRUE;

}   // End of LinkList member function CRegObject



//
// CUnRegObjByPtr( ListItem* item )
//      Unregister an item by passing in its pointer
//
BBOOL _pascal_ LinkList::CRemoveItemByPtr (ListItem *item )
{
    return RemoveItem( item );
}

