#ifndef _LINKLIST_H_
#define _LINKLIST_H_

#include "classes.h"

class ListItem {
protected:
    ListItem *next;
public:
    _pascal_ ListItem( void ):next(0)       {}
    _pascal_ ~ListItem()                    {}

//andout    virtual int _pascal_ identify(void)     { return LISTITEM_ID; }
    ListItem * _pascal_ CGetNext( void )    { return next; }
    void _pascal_ CSetNext( ListItem *n )       { next = n; }

    //
    // Put as many friends as you like or you can use the CGetNext and
    // CSetNext function to access next.  Although declaring a class
    // as friend is not a recommended programming practice, but it's
    // better than declaring next as public I guess.
    //
    friend class LinkList;
    friend class ObjList;
    friend class ObjMgr;
    friend class ViewMgr;
};

//
// A link list to hold objects
//
class LinkList {
protected:
    unsigned        TotalItem, CurrentIdx;
    ListItem        *ListHead, *ListTail, *Current;

    //
    // This function will remove an item if it exist no matter
    // where the item is. (head, tail, middle)
    //
    BBOOL  _pascal_ RemoveItem( ListItem * );

public:
    //
    // Constructor and Destructor
    //
    _pascal_ LinkList( void )
        :TotalItem(0), ListHead(0), ListTail(0), Current(0) { }
    _pascal_ ~LinkList()            { }

    //
    // Basic operations for linked list
    //
    virtual BBOOL    _pascal_ CAddItem ( ListItem* );
    virtual BBOOL    _pascal_ CRemoveItemByPtr  ( ListItem* );

    //
    // Some extended operations( not implemented yet )
    //
/*
    virtual ListItem* _pascal_ CInsBefore( ListItem* = 0 );
    virtual ListItem* _pascal_ CInsAfter( ListItem* = 0 );
    virtual int _pascal_ CRemoveCurrent( void );
    virtual int _pascal_ CDeleteAll( void );
*/

};

#endif
