#include "vidinter.h"

int __mouse_x = 0, __mouse_y = 0, __mouse_button = 0, __mouseFrozen = 0;
static int mouseMinx = 0, mouseMaxx = v_XMax, 
			mouseMiny = 0, mouseMaxy = v_YMax;
static int oldx = 0, oldy = 0, scale = 1, mouseHidden = 1;
			
static char back[256], *mouseCursor;

static void __mouseEventHandler( int button, int dx, int dy )
{
	__mouse_button = button;
	if ( __mouseFrozen ) return;

	__mouse_x += dx * scale;
	__mouse_y += dy * scale;
	
	if( __mouse_x < mouseMinx ) __mouse_x = mouseMinx;
	if( __mouse_x > mouseMaxx ) __mouse_x = mouseMaxx;
	if( __mouse_y < mouseMiny ) __mouse_y = mouseMiny;
	if( __mouse_y > mouseMaxy ) __mouse_y = mouseMaxy;
	
	if( mouseHidden ) goto do_not_update_mouse_cursor;
	
	gl_putbox( oldx, oldy, 5, 5, back );
	gl_getbox( __mouse_x, __mouse_y, 5, 5, back );
	gl_fillbox( __mouse_x, __mouse_y, 5, 5, 50 );
	
do_not_update_mouse_cursor:	
	oldx = __mouse_x;
	oldy = __mouse_y;	
}

void __initMouseDriver()
{
	static __inited = 0;
	if ( !__inited ) {
		__mouse_x = __mouse_y = __mouse_button = 0;
		mouse_seteventhandler( __mouseEventHandler );
		gl_getbox( oldx, oldy, 5, 5, (void*)back );
		__inited = 1;
	}
}

void __showMouse()
{
	if ( mouseHidden ) {
		mouseHidden = 0;
		gl_getbox( __mouse_x, __mouse_y, 5, 5, back );
		__mouseEventHandler( __mouse_button, 0, 0 );
	}
}

void __hideMouse()
{
	if ( !mouseHidden ) {
		mouseHidden = 1;
		gl_putbox( oldx, oldy, 5, 5, back );
	}
}

void __mouseSetCur( char* cur )
{
	mouseCursor = cur;
}

void __mouseWindow( int x1, int y1, int x2, int y2 )
{
	mouseMinx = x1;
	mouseMaxx = x2;
	mouseMiny = y1;
	mouseMaxy = y2;
}

//#define TEST_MOUSE
#ifdef TEST_MOUSE
main()
{
	_InitVideo;
	__showMouse();
	while(1) mouse_update();
	_RestoreVideo;
}
#endif
