#ifndef _MACROS_H_
#define _MACROS_H_
//#include "mouinter.h"
#include "classes.h"
#include "depend.h"

#ifdef __MSDOS__

#define KBHIT
#ifdef KBHIT
	#define KTAB  9
	#define KSTAB 315
	#define KRET  13
	#define KESC  27
#endif

#define _FAR_ far
// #define _FAR_

#define _pascal_    pascal

#else

#define _pascal_

#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef WORD
typedef unsigned int WORD;
#endif

#ifndef BOOL
typedef int BOOL;  // == 0 => false  anything not 0 => true
#endif

#ifndef BBOOL
typedef BYTE BBOOL; // byte bool ( for small memory usage )
#endif

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif

//
// check if a point is in a rectangle
//
#define PointInRect(px, py, rx1, ry1, rx2, ry2 ) \
    (px >= rx1 && px <= rx2 && py >= ry1 && py <= ry2)




//
// Check if the mouse pointer is in a rectangle
//
#define MouseInRect(rx1, ry1, rx2, ry2 ) \
    PointInRect((int)m_MouseX, (int)m_MouseY, (int)rx1, \
                (int)ry1, (int)rx2, (int)ry2 )




//
// Check if the mouse pointer is on Obj (ScrObj or base on it)
//
#define IsMouseOnObj(Obj ) \
    (MouseInRect(Obj->x1(), Obj->y1(), Obj->x2(), Obj->y2() ))
#define IsPointOnObj(x, y, Obj ) \
    (PointInRect(x, y, Obj->x1(), Obj->y1(), Obj->x2(), Obj->y2() ))


//
// beep (frequency, duration )  Make some sound on the pc speaker
//
#ifdef __MSDOS__
	#define beep(f, d )    { sound(f ); delay(d ); nosound(); }
#endif

#define isClick( msg, btn2chk ) ((Button::CAction(msg, btn2chk)) == CLICK)
#define string( a ) strcpy( new char[strlen(a)+1], a )

#ifdef __LINUX__
	#define beep(f, d )
#endif




//
// macros to declare object handlers
//
// First one: Declare a variable pointer to an object handler
// Second one: Declare a function to be an object handler
// Third one: Declare an object handler as a member of a class
//
#define ObjH(FuncName ) int _pascal_ (*FuncName) (Message *)
#define DeclareObjH(FuncName ) int _pascal_ FuncName(Message *msg)
#define DeclareObjHClass(ClassName, FuncName ) \
        int _pascal_ ClassName::FuncName(Message *msg)
typedef int _pascal_ (*OBJH)(Message *);



//
// macros to declare interceptors
//
// 1st: delcare a pointer
// 2nd: declare an interceptor
// 3rd: declare an interceptor as a member of a class
//
#define IntC(FuncName ) int _pascal_ (*FuncName) (const Object*)
#define DeclareIntC(FuncName ) \
        int  _pascal_ FuncName(const Object  *_ObjPtr )
#define DeclareIntCNoPtr( FuncName ) \
        int  _pascal_ FuncName(const Object* )
#define DeclareIntCClass(ClassName, FuncName ) \
        int  _pascal_ ClassName::FuncName( const Object  *_ObjPtr )
#define DeclareIntCClassNoPtr(ClassName, FuncName ) \
		int  _pascal_ ClassName::FuncName( const Object* )

typedef int  _pascal_ (*INTC)(const Object *);

#endif
