#include "object.h"
#include "vidinter.h"
#include "viewmgr.h"
#include "timer.h"

#include <stdio.h>
#include <stdlib.h>

#ifdef __MSDOS__
#include <alloc.h>
#include <dos.h>
#endif

ScrObj* ScrObj::HighLite = 0;

//
// Member functions for class Message
//
#ifdef MSG_CACHE_ON

Message*    Message::Cache[MSG_CACHE_SIZE];
int         Message::nCache = 0;

static WORD Index = 0;

#ifdef ADDRESS_CHECK_CACHE
char* PoolUpperBound;
char* InitPool()
{
	WORD poolSize = sizeof(Message) * MSG_CACHE_SIZE;
    char* tmpPtr = new char [poolSize];
	PoolUpperBound = (char*)(tmpPtr + poolSize);
    return tmpPtr;
}
#else
    BBOOL Message::cacheOn = TRUE;
#endif

char* Message::CachePool =
    #ifdef ADDRESS_CHECK_CACHE
        InitPool();
    #else
        new char [sizeof(Message) * MSG_CACHE_SIZE];
    #endif

void* _pascal Message::operator new( size_t s )
{
#ifndef ADDRESS_CHECK_CACHE
        cacheOn = TRUE;
#endif

    if ( (s == sizeof(Message)) && nCache )
		return Cache[--nCache];
    else if ( Index == MSG_CACHE_SIZE ) {
#ifndef ADDRESS_CHECK_CACHE
        cacheOn = FALSE;
#endif
        return ::operator new(s);
    } else
        return ((char*)CachePool + (Index++ * sizeof(Message)));
}

void _pascal_ Message::operator delete( void* pObj )
{
	if ( !pObj ) return;
#ifdef ADDRESS_CHECK_CACHE
    if ( pObj >= CachePool && pObj < PoolUpperBound )
#else
    if ( ((Message*)pObj)->isCacheItem )
#endif
        Cache[nCache++] = (Message*)pObj;
    else
        ::operator delete( pObj );
}

#endif   // msg cache stuff

//
// Member functions for class Object
//

Object&  _pascal_ Object::operator= (const Object &y)
{
    if (this != &y ) {
        (*this).ObjID = y.ObjID;
        (*this).sHandler = y.sHandler;
    }
    return *this;
}

//
// Member functions for class ScrObj
//

int   _pascal_ ScrObj::CRestoreOutLine( void )
{
    if ( this != HighLite )
                return 0;
    HighLite = 0;

    m_HideMouse;
    CDrawOutLine();

    return OutLineColor;
}


int   _pascal_ ScrObj::CHighLiteOutLine( void )
{
    if ( HighLite )
        if ( HighLite != this ) {
            HighLite->CRestoreOutLine();
        }
        else
            return 0;
    HighLite = this;

    m_HideMouse;
    CDrawOutLine( HighLiteColor );

    return HighLiteColor;
}

_pascal_ ScrObj::ScrObj( int x1, int y1, int x2, int y2, OBJH h, WORD id )
    :Object(h, id ),sX1(x1),sY1(y1),sX2(x2),sY2(y2)
{}

_pascal_ ScrObj::~ScrObj()
{
    if ( HighLite == this )
        HighLite = 0;
}

void  _pascal_ ScrObj::CLinkShowObject( void )
{
    ScrObj *runPtr = this;
	while ( runPtr ) {
        runPtr->CShowObject();
		runPtr = (ScrObj*)runPtr->next;
    }
}

ScrObj&  _pascal_ ScrObj::operator= (const ScrObj &y)
{
    if (this != &y ) {
        (*this).sX1 = y.sX1;
        (*this).sY1 = y.sY1;
        (*this).sX2 = y.sX2;
        (*this).sY2 = y.sY2;
        Object::operator = (y);
    }
    return *this;
}


void  _pascal_ ScrObj::CClrContext( int color )
{
    v_ObjectFaceFill( sX1+1, sY1+1, sX2, sY2, color );
}

void  _pascal_ ScrObj::CShowObject( void )
{
    m_HideMouse;
    CDrawOutLine();
    m_ShowMouse;
    ViewMgr::CSendMsg( this, REDRAW );
}


void  _pascal_ ScrObj::CDrawOutLine( int color )
{
    v_PutLine (sX2, sY1, sX2, sY2, color );
    v_PutLine (sX1, sY2, sX2, sY2, color );
    v_PutLine (sX1, sY1, sX2, sY1, color );
    v_PutLine (sX1, sY1, sX1, sY2, color );
}


