#ifndef _TIMER_H_
#define _TIMER_H_

//
//
// Timer Class definitions
// Written by Joel Chen 1994-1995
// For WDG Library by Joel Chen
//
//

#include "depend.h"

#if USE_TIMER

#ifdef __MSDOS__
// normal timer only has effect under msdos.
#if NORMAL_TIMER
    #define NormalTimer
#endif
#endif

#ifdef __LINUX__
    #ifndef NormalTimer
	#define NormalTimer
	#endif
#endif

#ifndef NormalTimer
#include "interr.h"
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

class Timer {
private:
    unsigned elapsedTime;
    unsigned startTime;

public:
    _pascal_ Timer( unsigned d = 0 ) { elapsedTime = startTime = 0;}

    void _pascal_ reset( void )     { elapsedTime = startTime = 0; }
    unsigned _pascal_ start( void );
    unsigned _pascal_ stop( void );
    unsigned _pascal_ Continue( void );
    unsigned _pascal_ peekTime( void );
    void _pascal_ RunDown( unsigned );
    unsigned _pascal_ time( void )  { return elapsedTime; }
    void _pascal_ set( unsigned t ) { startTime -= t; }
#ifndef NormalTimer
    static int _pascal_ ChangeSpeed( unsigned = 1, unsigned = 0xffff );
    static int _pascal_ CRemoveTimer() { return ChangeSpeed(0); }
// Install the timer handler.  The function will return zero if caller is
// trying to change clock speed and NormalTimer is on.  If NormalTimer is
// off, function will always return 1 on success.
    static int  _pascal_
        CInstallTimer( unsigned newDiv = 1, unsigned sp = 0xffff )
        {
            // fast timer always work (even use as normal timer.)
            if ( ChangeSpeed( newDiv, sp ) ) return 1;
            return 0;
        }
#else
    static void CRemoveTimer() {}
    static int  _pascal_
        CInstallTimer( unsigned newDiv = 1, unsigned sp = 0xffff )
        { return ( newDiv == 1 && sp == 0xffff ); }
#endif
};

#endif
#endif
