#ifdef MOU_INTERFACE

#include "xlib.h"
#include "xmouse.h"

//
// Mouse Functions expected to use in ObjMgr
//
#define m_MouseInit                     x_mouse_init()
#define m_MouseDeInit                   x_mouse_remove()


// Redraw the mouse cursor and read x & y corrdinates
#define m_UpdateMouse
// x_update_mouse()

#define m_MouseX                        MouseX
#define m_MouseY                        MouseY
#if !AUTO_MOUSE
#define m_ShowMouse
// x_show_mouse()

#define m_MUSTShowMouse
#else
#define m_ShowMouse
#define m_MUSTShowMouse
// x_show_mouse()

#endif
#define m_HideMouse
// x_hide_mouse()

#define m_MouseHidden                   MouseHidden
#define m_MouseButtonStatus             MouseButtonStatus
#define m_FreezeMouse                   MouseFrozen = 1
#define m_DeFreezeMouse                 MouseFrozen = 0
#define m_MouseGotoXY( x, y )           x_position_mouse(x,y)

//
// Other functions not expected to use
//
// Set the cursor to cur <char _FAR_ *> in color <int>
//
#define m_MouseSetCur(cur, color )
// x_define_mouse_cursor(cur, color )

#define m_MouseSetXY(x, y )              x_position_mouse(x, y )

// Set a rect the pointer is limited in
//
#define m_MouseWindow(x1, y1, x2, y2 )      x_mouse_window(x1, y1, x2, y2 )

// Set the mouse cursor's color
//
#define m_MouseCurColor(color )          MouseColor = color;

#define CLICK  128 // 10000000
#define HOLD   16  // 00010000
#define DOUBLE 8   // 00001000
#define BUTTON 7   // 00000111

#define LCLICK (CLICK|LEFT_PRESSED)
#define MCLICK (CLICK|MIDDLE_PRESSED)
#define RCLICK (CLICK|RIGHT_PRESSED)
#define LHOLD  (HOLD|LEFT_PRESSED)
#define MHOLD  (HOLD|MIDDLE_PRESSED)
#define RHOLD  (HOLD|RIGHT_PRESSED)

#endif
