#include <stdio.h>
#include "viewmgr.h"
#include "vidinter.h"
#include "timer.h"
#include "debug.h"
#include "actids.h"
#include "button.h"

#ifdef __MSDOS__
#include <dos.h>
#include <conio.h>
#endif

#define delayTime 10
#define downDelay 10

BYTE    ViewMgr::ButtonStatus = 0;
BYTE    ViewMgr::ButtonDown = 0;
BBOOL   ViewMgr::objFocus = FALSE;
BBOOL   ViewMgr::ContinuousHold = TRUE;
#ifdef TRACE_MOUSE
BBOOL   ViewMgr::TraceMouse = TRUE;
#endif
Timer   ViewMgr::downTimer = 0;
Timer   ViewMgr::DCTimer = 0;
int     ViewMgr::nClickCount = 0;
ScrObj* ViewMgr::WorkObj = 0;
Message* ViewMgr::otoSender = 0;
Message* ViewMgr::otoTail = 0;

// Global Variables

ObjMgr	*CurrentMgr = 0;	// point to current manager in control
int 	objMouseX = 0;		// mouse x for objects (see header file)
int 	objMouseY = 0;		// mouse y for objects

// End of global variables

void  _pascal_ ViewMgr::CResetObjectHandler( void )
{
    // static members
    ButtonStatus = ButtonDown = 0;
    WorkObj = 0;
    objFocus = FALSE;
#ifdef TRACE_MOUSE
    TraceMouse = TRUE;
#endif

    // global variables
    objMouseX = 0;
    objMouseY = 0;
}

void  _pascal_ ViewMgr::CMakeMouseOnNoObject( void )
{
    WorkObj = 0;
	ButtonDown = 0xf1; // invalidate buttondown
}

void  _pascal_ ViewMgr::CToggleObjectFocus( void )
{
    objFocus = !objFocus;
    /*
	if ( objFocus ) objFocus = 0;
	else            objFocus = 1;
    */
}


void  _pascal_ ViewMgr::CReset( void )
{
    Current = 0;
}

int   _pascal_ ViewMgr::CMgrLoop        (void )
{
	ViewMgr* OldMgr = (ViewMgr*)CurrentMgr;
	ScrObj * objPtr;

	if ( OldMgr ) {
		objPtr = (ScrObj*)OldMgr->Current;
        if ( objPtr )
            objPtr->CRestoreOutLine();
	}
	CShowObject();

	return ObjMgr :: CMgrLoop();
}

ViewMgr&  _pascal_ ViewMgr::operator= (const ViewMgr &y)
{
    if (this != &y ) {
		ObjMgr::operator = (y);
        ScrObj::operator = (y);
    }
    return *this;
}

void  _pascal_ ViewMgr::AdvanceMsg( void )
{
    otoSender = otoSender->next;
    if ( !otoSender ) otoTail = 0;
}


void _pascal_ ViewMgr::CSendMsg( Object *tg, int id,
                        Object *src, BYTE _mb, int key )
{
    if ( !tg ) return;
    Message *tmpMsg = new Message( tg, id, src, _mb, key );
    if ( !tmpMsg ) {
        beep( 500, 100 );
        return;
    }
    if ( otoTail ) otoTail->next = tmpMsg;
    else           otoSender = tmpMsg;
    otoTail = tmpMsg;
}

void _pascal_ ViewMgr::CLinkSendMsg( Object *tg, int id,
                            Object *src, BYTE _mb, int key )
{
    while ( tg ) {
        CSendMsg( tg, id, src, _mb, key );
        tg = (Object*)tg->next;
    }
}
void  _pascal_ ViewMgr::CShowAllObject( void )
{
    if (ObjHead)
        ((ScrObj*)ObjHead)->CLinkShowObject();
}

int _pascal_ ViewMgr::CAddClick( const Message *msg )
{
    static ScrObj* lastObj;
    static BYTE Clicked;

    if (Clicked == msg->mouButton &&
        lastObj == (ScrObj*)msg->ToObj &&
        DCTimer.time() < delayTime )        {

        debug_msg( "add Click. \n" );
        nClickCount ++;
    } else if ( downTimer.time() < downDelay ) {

        lastObj = (ScrObj*)msg->ToObj;
        nClickCount = 1;
        Clicked = msg->mouButton;
        DCTimer.start();
    }

    return nClickCount;

}

static void _pascal_ ShowBorder( Object* obj, BBOOL draw = TRUE )
{
    if ( draw ) ((ScrObj*)obj)->CHighLiteOutLine();
    else ((ScrObj*)obj)->CRestoreOutLine();
}


BBOOL  _pascal_ ViewMgr::VerifyObject( void )
{
    if ( objFocus )
        if ( WorkObj )
            return TRUE;
        else
            return FALSE;
	WorkObj = (ScrObj*) Current;
    if ( WorkObj && WorkObj->CMouseInMe() )
        return TRUE;
	else {
        // Find the object mouse points to
        WorkObj = (ScrObj*)ObjHead;
        while ( WorkObj ) {
            if ( WorkObj->CMouseInMe() ) break;
            WorkObj = (ScrObj*)WorkObj->next;
        }
    }
	if ( WorkObj ) {
        Current = WorkObj;
        return TRUE;
    }
    return FALSE;
}

#ifdef TRACE_MOUSE
void  _pascal_ ViewMgr::CheckMouseTrace( void )
{
    static int oldMx, oldMy;
    static int newMx, newMy;
    static Object *sentoff = 0;

	oldMx = newMx;
	oldMy = newMy;

    if (oldMx != m_MouseX || oldMy != m_MouseY ) {

        objMouseX = newMx = m_MouseX;
        objMouseY = newMy = m_MouseY;

        if ( !ButtonStatus ) {
            if ( !objFocus ) {

                WorkObj = (ScrObj*) Current;

                if ( !(WorkObj && WorkObj->CMouseInMe()) ) {
                    if ( WorkObj && WorkObj != sentoff ) {
                        ViewMgr::CSendMsg( WorkObj, MOUSE_OFF, 0, 0 );
                        ShowBorder( WorkObj, FALSE );
                        sentoff = WorkObj;
                    }

                    // Find the object mouse points to
                    WorkObj = (ScrObj*)ObjHead;
                    while ( WorkObj ) {

                        if ( WorkObj->CMouseInMe() ) break;
                        WorkObj = (ScrObj*)WorkObj->next;
                    }
                }
            }
        } else
            return ;
        // Did we find an object?
        if ( WorkObj ) {
            ViewMgr::CSendMsg( WorkObj, MOUSE_ON, 0, 0 );
            ShowBorder( WorkObj );
            Current = WorkObj;
            sentoff = 0;
        }
    }
}
#endif

void  _pascal_ ViewMgr::KeyBoardHandler( void )
{
    if ( kbhit() ) {
        int key = getch();
        if ( !key ) key = getch() + 0xff;
        switch ( key ) {
            case 389:
                stop = 1;
                break;
            default:
                CSendMsg( WorkObj, KEY_DOWN, 0, 0, key );
                break;
        }
    }
}

void _pascal_
ViewMgr::MouseHandler ( void )
{
	// Read mouse button status
	ButtonStatus = m_MouseButtonStatus;

	// check if button status have change since last time
    if (( ButtonDown != ButtonStatus )) {
        // Record Mouse Coordinates
		objMouseX = m_MouseX;
		objMouseY = m_MouseY;

        // Button is now up, but it was on an object.  So it's a click
        if ( !ButtonStatus && ButtonDown && WorkObj) {

            DCTimer.stop();     // Stop the double click timer
            downTimer.stop();   // Stop the holding button timer

            // Make sure the cursor is still on object before send click
            if (WorkObj->CMouseInMe() || objFocus )

                CSendMsg( WorkObj, 0, 0, (BYTE)ButtonDown | CLICK );
            else
            // otherwise tell object the click is canceled
                CSendMsg( WorkObj, CANCEL_CLICK, 0, 0 );

        // Otherwise the button is being pushing down
        } else if ( ButtonStatus ) {

            // if mouse was holding on an object, let the object
            // know that mouse is gone
            if ( ButtonDown && Current )
                CSendMsg(WorkObj,CANCEL_CLICK,0, 0 );

            // Make sure the mouse is not click outside the viewing window
			if (slave && !this->CMouseInMe() && CGiveUpControl() ) {

                stop = 1;
                WorkObj = 0;
                return;

            // Call VerifyObject to obtain a new object
            } else if ( VerifyObject() )

                // VerifyObject found that mouse is pushed down on an object
                // and WorkObj is now point to that object
                CSendMsg( WorkObj, 0, 0, (BYTE)ButtonStatus|HOLD );

            // Restart the timer to count how long the button is holding down
            downTimer.start();
		}
        // And save the status of the mouse button to ButtonDown
        ButtonDown = ButtonStatus;

    } else if (ButtonDown && WorkObj ) {  // keep sending HOLD
        static int oldx = -1, oldy = -1;
        objMouseX = m_MouseX;
        objMouseY = m_MouseY;

        if ( ContinuousHold || objMouseX != oldx || objMouseY != oldy ) {

            if ( WorkObj->CMouseInMe() || objFocus )
                CSendMsg(WorkObj, 0, 0, (BYTE)ButtonDown|HOLD);
            else
                CSendMsg(WorkObj, MOUSE_OFF, 0, 0 );
            oldx = objMouseX;
            oldy = objMouseY;
        }
	}
#ifdef TRACE_MOUSE
    else if ( TraceMouse )   CheckMouseTrace();
#endif
}

// ** This is the ViewMgr's object handler
void _pascal_
ViewMgr::ObjHandler (void )
{
	// Check object to object communication
    if ( otoSender ) {
        static Object *tmpObjPtr;
        Message *tmpMsgPtr = otoSender;

//        AdvanceMsg();
        otoSender = otoSender->next;
        if ( !otoSender ) otoTail = 0;

        tmpObjPtr =(Object*) tmpMsgPtr->ToObj;

        if (tmpObjPtr && tmpObjPtr->sHandler )
            tmpObjPtr->sHandler( tmpMsgPtr );

        delete tmpMsgPtr;
    } else {
        m_MUSTShowMouse;    // Guarrantee work! no change will be made to this
        KeyBoardHandler();
        MouseHandler();
    }
}

// -- End of file ViewMgr.cpp -- //
